<?php
//	DBMathModel򤷤ν

include("setSession.inc");
require("readXmlFuncs.php");
require("rwFile.php");

$headtitle="Select Job";
$bodytitle="Select Job";
$usage="This model comes from ";
$cssfile="global.css";
$preUrl = "../Life/opener.html";

if (file_exists($sessionDir)) {			// åDir
	exec ("/bin/rm -rf $sessionDir");	// 
}
mkdir($sessionDir, 0700);	// ƥåDir
chdir($sessionDir);

$xml = stripslashes($xml);
// DBΥǡöե˽񤭽Ф
if (($fp = fopen ($mathFile, "w"))) {
	fwrite($fp, $xml);
	fclose ($fp);
} else {
	$log = "";
	postError("Cannot open Math-Model file.", $log, $preUrl);
}
$xml="";

// DTD򥳥ԡƤ
system("cp ../../Tools/etc/sanac.dtd .".$batch_log, $out);
if ($out != 0) {	// DTDԡǤʤ
	$log = readTextFile2($logFile);
	postError("Cannot copy DTD.", $log, $preUrl);
}

// MathModelեʬ䤹롼ư
system($dirBin."dividedata -I".$mathFile.$batch_log, $out);
if ($out != 0) {	// եʬ롼󤬼Ԥ
	$log = readTextFile2($logFile);
	postError("Cannot parse Math-Model data.", $log, $preUrl);
}

// ơեɤ߹
if (($fp = fopen ($statusFile,"r"))) {
	$userinfo = fscanf ($fp,"%s\t%s\t%s\t%s\n");
	list ($my_path, $status, $convTypeValue_P, $convTypeValue_M) = $userinfo;
	fclose($fp);
} else {
	$log = "";
	postError("Cannot open status file.", $log, $preUrl);
}

// XMLեɤ߹
$titleValue = "";
$memoValue = "";
$equations = array();
if (($log = readXmlInfo($chemiFile))) {
	postError("XML parse error.", $log, $preUrl);
}
$usage = $usage."chemical equation.";

// ˥ȥǡ¸ߤФɤ߹
if (file_exists($ctrlFile)) {
	if (($fp = fopen ($ctrlFile,"r"))) {
		while($info = fscanf($fp,"%s\t;\t%s\n")) {
			list ($my_name, $value) = $info;
			if ($my_name == "SOLVER") {
				$solverNo = $value;
			} else if ($my_name == "P_SURVEY") {
				$f_survey= $value;
			} else if ($my_name == "PARALLEL") {
				$f_parallel= $value;
			}
		}
		fclose($fp);
	} else {
		$log = "";
		postError("Cannot read CTRL file.", $log, $preUrl);
	}
	if ($solverNo < 10) {
		$analysisTypeValue = 1;
	} else if ($solverNo < 20) {
		$analysisTypeValue = 2;
	} else {
		$analysisTypeValue = 3;
	}
}
$f_useSsys = false;

// Ʋ̶̤ΥǡǼ
session_register("my_id");
session_register("my_path");
session_register("status");
session_register("titleValue");
session_register("memoValue");
session_register("equations");
session_register("convTypeValue_P");
session_register("convTypeValue_M");
session_register("analysisTypeValue");
session_register("f_surveyValue");
session_register("f_parallelValue");
?>

<html>
	<head>
		<title><?php print $headtitle ?></title>
		<link rel="stylesheet" type="text/css" href="css/<?php print $cssfile ?>" />
	</head>
	<body id="body">
		<p id="bodytitle"><?php print $bodytitle ?></p>
		<div id="usage"><?php print $usage ?></div>
		<p id="title"><?php print $titleValue; ?></p>
		<p id="memo"><?php print $memoValue; ?></p>
		<hr id="line"/>
		<div id="contents">
			<p id="job_select">
				<a href="editUsrFunc.php">Go to [Edit Model Data].</a>
			</p>
<?php
	if ($status == "PARAM" || $status == "RESULT") {
?>
			<p id="job_select">
				<a href="selectAnalysis.php">Go to [Select Analysis Type].</a>
			</p>
<?php
	}
	if ($status == "RESULT") {
?>
			<p id="job_select">
				<a href="showResult.php?from=select">Go to [Results].</a>
			</p>
<?php
	}
?>
		</div>
	</body>
</html>
