#ifndef	LOGUTIL_H
#define	LOGUTIL_H 1

#ifndef WIN32
#include <syslog.h>
#endif

#define FNAME_SIZE 128

#ifndef WIN32
double	log_getElapseTime();
void	log_sys_t(char *format, ...);
int 	log_dbg_t(char *format, ...);
#endif
int		log_sysinit(int argc, char *argv[]);
void	log_sysfinalize();
void	log_sys(char *format, ...);

int		log_dbginit(int argc, char *argv[]);
void	log_dbgfinalize();
int 	log_dbg(char *format, ...);

int 	log_dbg_l(char *format, ...);

extern	char *Dbg_filename;
extern	int Dbg_line;
extern	int Dbg_Level;

#ifdef DBG
#define	DBGW(n,f)		((Dbg_Level>=(n)) ? log_dbg f : 0)
#define	DBGW_L(n,f)		Dbg_filename = __FILE__, Dbg_line = __LINE__, ((Dbg_Level>=(n)) ? log_dbg_l f : 0)
#define	DBGW_T(n,f)		((Dbg_Level>=(n)) ? log_dbg_t f : 0)
#else
#define DBGW(n,f)
#define DBGW_L(n,f)
#define DBGW_T(n,f)
#endif

#endif  // !LOGUTIL_H

