#ifndef _NR_MUTIL_H_
#define _NR_MUTIL_H_

extern void nr_add_matrix(double **A, double **B, double **C, long m, long n);
extern void nr_sub_matrix(double **A, double **B, double **C, long m, long n);
extern void nr_mult_matrix(double **A, double **B, double **C, long l, long m, long n);
extern double **nr_alloc_matrix(long nrl, long nrh, long ncl, long nch);
extern void nr_free_matrix(double **m, long nrl, long nrh, long ncl, long nch);
extern double *nr_alloc_vector(long nl, long nh);
extern void nr_free_vector(double *v, long nl, long nh);
extern int *nr_alloc_ivector(long nl, long nh);
extern void nr_free_ivector(int *v, long nl, long nh);
extern void nr_dump_matrix(char *name, double **A, long m, long n);

extern void nr_copy_origin0to1(double *src, double **trg, int row, int col);
extern void nr_copy_origin1to0(double **src, double *trg, int row, int col);

#endif /* _NR_MUTIL_H_ */
