/* 
 *
 * ѿ(x)̵ˤϴٲϤS-systemɬפȤʤ
 * ե롣
 * 1Ĥ V+,V-,g,h ׻뤿δؿե롣
 * ⤦ĤS-systemΥ桼ؿե롣S-systemΤΥѥ᡼ե
 * 򤬵ޤäƻǤβȾ嵭ե뤪᤿
 * ѥ᡼ե뤫̥ץˤ롣
 *
 * 
 * ɽŸͥǥåѿѴ줿ܹȡݹʬΥ롣
 * V+V- 򤽤줾ĥ꡼Ÿѿ(ѿޤ)ʬgh롣
 * 嵭νg,hΥ/ǥåΥե饰ƤȤ
 *   S-systemfvecfjac롣
 *
 * 嵭Ϣνϡñ̤ǹԤ줾ľܥե˽񤭽ФƤ
 *
 */
#include "checkdae.h"

static int make_Sdata(Expression_T *equation, int n_var, int n_const, FILE *fp_GH);
static int separate_terms(char *str_eq, char *str_plus, char *str_minus);
static int get_preGH(Node_T *root, char *str, int n_var, int n_const, char *label_V,
			   	char *label_GH, int index, int *cnt, int *flag, FILE *fp_out);
static int write_S_usrfunc(FILE *fp_out);
static int write_GEhead(FILE *fp_out, ParamBase_T *param_base, int n_param,
			   				int n_var, int n_const);
static void write_GEtail(FILE *fp_out, int n_var, int n_const);
static void write_Sfvec(FILE *fp_out, int n_var, int n_const, char *label, int *flag);
static void write_Sfjac(FILE *fp_out, int n_var, int n_const, char *label, int *flag, int index);
static int write_S_funcs(FILE *fp_out, char *fname);

/*---------------------- Set_Ssystem -------------------------------------------
 *
 *	S-systmϢᥤ󡣽񤭽ФѥեΥץ
 *
 */
int
Set_Ssystem(EqSystem_T *mySystem, char **fname)
{
	int i; //, j, cnt_g=0, cnt_h=0;
	int n_var;		/* ѿο */
	int n_const=0;	/* ѿο */
	FILE *fp_GH, *fp_S;

	if((fp_GH = fopen(fname[FILE_G], "w")) == NULL){
		log_sys("#  Cannot open %s\n", fname[FILE_G]);
		goto err;
	}

	if((fp_S = fopen(fname[FILE_S], "w")) == NULL){
		log_sys("#  Cannot open %s\n", fname[FILE_S]);
		goto err;
	}

	n_var = mySystem->n_varY;
	for (i=mySystem->param_base[0].max_index-1; i>=0; i--) {
		if (mySystem->param_base[0].param[i].f_isUsed) {
			break;
		}
	}
	n_const = i + 1;

	write_GEhead(fp_GH, mySystem->param_base, mySystem->n_param, n_var, n_const);
	
	if (make_Sdata(mySystem->equation, n_var, n_const, fp_GH)) goto err;

	write_GEtail(fp_GH, n_var, n_const);

	if (write_S_usrfunc(fp_S)) goto err;

	fclose(fp_GH);
	fclose(fp_S);

	return 0;

err:
	log_sys("## Error in Set_Ssystem.\n");
	return -1;
}

/*---------------------- make_Sdata -------------------------------------------
 *
 *	ǡΥᥤ롼
 *	g,hΥǡϽϥեľܽ񤭽Ф(Ҵؿ)S-systemѤ
 *	fvec,fjacʬΥ뤿ˤľܥƥݥե˽񤭽Ф
 *
 */
static int
make_Sdata(Expression_T *equation, int n_var, int n_const, FILE *fp_GH)
{
	int i, j, cnt_g=0, cnt_h=0;
	int *f_g;		/* gΥorǥå */
	int *f_h;		/* hΥorǥå */
	int f_havePlus;		/* V+  */
	int f_haveMinus;	/* V-  */
	char str_plus[BUFFSIZE];	/* V+ */
	char str_minus[BUFFSIZE];	/* V- */
	Node_T *plus=NULL, *minus=NULL;
	FILE *fp_fvec, *fp_fjac;

	if((fp_fvec = fopen(FNAME_SV, "w")) == NULL){
		log_sys("#  Cannot open %s\n", FNAME_SV);
		goto err;
	}

	if((fp_fjac = fopen(FNAME_SJ, "w")) == NULL){
		log_sys("#  Cannot open %s\n", FNAME_SJ);
		goto err;
	}

	f_g = (int *) calloc(n_var+n_const+1, sizeof(int));
	if (f_g == NULL) {
		log_sys("#  Cannot allocate f_g.\n");
		goto err;
	}
	f_h = (int *) calloc(n_var+n_const+1, sizeof(int));
	if (f_h == NULL) {
		log_sys("#  Cannot allocate f_h.\n");
		goto err;
	}

	for (i=0; i<n_var; i++) {	/* Υ롼 */
		f_havePlus = f_haveMinus = false;

		/* Cǽľ */
		if (Set_expr(equation[i].root, false) < 0) {
			goto err;
		}

		/*  V+  V- ʬ䤹롣 */
		if (separate_terms(equation[i].root->expr, str_plus, str_minus) < 0) {
			goto err;
		}

		memset(f_g, 0, sizeof(f_g)*(n_var+n_const+1));
		memset(f_h, 0, sizeof(f_h)*(n_var+n_const+1));

		/* V+Ф˴ؤ񤭽Ф */
		if (strlen(str_plus) > 0) {
			f_havePlus = true;
			if (get_preGH(plus, str_plus, n_var, n_const,
								   	"v_plus", "g", i, &cnt_g, f_g, fp_GH)) goto err;
		}

		/* V-Ф˴ؤ񤭽Ф */
		if (strlen(str_minus) > 0) {
			f_haveMinus = true;
			if (get_preGH(minus, str_minus, n_var, n_const,
								   	"v_minus", "h", i, &cnt_h, f_h, fp_GH)) goto err;
		}

		/* fvec ν񤭽Ф */
		fprintf(fp_fvec, "fvec[%3d] = ", i+1);
		if (f_havePlus) {
			fprintf(fp_fvec, "kplus[%d]", i+1);
			write_Sfvec(fp_fvec, n_var, n_const, "g", f_g);
		}
		if (f_haveMinus) {
			fprintf(fp_fvec, " - kminus[%d]", i+1);
			write_Sfvec(fp_fvec, n_var, n_const, "h", f_h);
		}
		fprintf(fp_fvec, ";\n");

		/* fjac ν񤭽Ф */
		for (j=1; j<=n_var; j++) {
			if (f_g[j] || f_h[j]) {
				fprintf(fp_fjac, "fjac[%3d][%3d] = ", i+1, j);
				if (f_g[j]) {
					fprintf(fp_fjac, "kplus[%d]", i+1);
					write_Sfjac(fp_fjac, n_var, n_const, "g", f_g, j);
				}
				if (f_h[j]) {
					fprintf(fp_fjac, " - kminus[%d]", i+1);
					write_Sfjac(fp_fjac, n_var, n_const, "h", f_h, j);
				}
				fprintf(fp_fjac, ";\n");
			}
		}
	}

	fclose(fp_fvec);
	fclose(fp_fjac);

	return 0;

err:
	log_sys("#  equation = '%s'\n", equation[i].root->expr);
	log_sys("#  V+ = '%s', V- = '%s'\n", str_plus, str_minus);
	log_sys("## Error in make_Sdata.\n");
	return -1;
}

/*---------------------- get_preGH -------------------------------------------
 *
 *	g,h ΤȤV+V-񤭽Ф
 *
 */
static int
get_preGH(Node_T *root, char *str, int n_var, int n_const, char *label_V, char *label_GH,
									int index, int *cnt, int *flag, FILE *fp_out)
{
	int i;
	char str_target[BUFFSIZE];	/* ʬо */

	/* Υĥ꡼Υ곫 */
	if (root != NULL) Del_tree(root);

	/* оݼĥ꡼Ÿ */
	if (Make_node(&root, str)) {
		goto err;
	}
	if (Set_expr(root, true)) {
		goto err;
	}

	/* V+ or V- ν񤭽Ф */
	fprintf(fp_out, "\t%-7s[%3d] = %s;\n", label_V, index+1, root->expr);

	/* Dependent ѿ˴ؤޥȥåν񤭽Ф */
	for (i=1; i<=n_var; i++) {
		sprintf(str_target, "y[%d]", i);
		if (strstr(str, str_target) > 0) {
			if (Make_diff(root, str_target, true)) goto err;
			fprintf(fp_out, "\t%sd[%3d][%3d] = %s;\n", label_GH, index+1, i, root->diff);
			flag[i] = ++*cnt;
		}
	}

	/* Independent ѿ˴ؤޥȥåν񤭽Ф */
	for (i=1; i<=n_const; i++) {
		sprintf(str_target, "%s[%d]", CONSTANT_PLAYER, i);
		if (strstr(str, str_target) > 0) {
			if (Make_diff(root, str_target, true)) goto err;
			fprintf(fp_out, "\t%si[%3d][%3d] = %s;\n", label_GH, index+1, i, root->diff);
			flag[n_var+i] = ++*cnt;
		}
	}

	return 0;

err:
	log_sys("## Error in get_preGH.\n");
	return -1;
}

/*---------------------- separate_terms -------------------------------------------
 *
 *  ܹȡݹʬ֤
 *	ǤѿΥǥåϿͲƤ뤳ȤꤷƤΤ
 *	[]ˤʤ
 *
 */
static int
separate_terms(char *str_eq, char *str_plus, char *str_minus)
{
	char *cp, *cp_P, *cp_M, str_tmp[BUFFSIZE], **cp_tmp;
	int cnt_bracket=0;
	int f_isPlus=true;

	cp = str_eq;
	cp_P = str_plus;
	cp_M = str_minus;

	for (;;) {
		if (*cp == ' ' || *cp == '\t' || *cp == '\n') {
			cp++;
		} else if (*cp == '\0') {
			break;
		} else if (isdigit(*cp) || *cp == '.' ) {	/*  */
			double val;
			int i;
			val = strtod(cp, &cp);
			sprintf(str_tmp, "%g", val);
			for (i=0; i<strlen(str_tmp); i++) {
				if (f_isPlus) {
					*cp_P++ = str_tmp[i];
				} else {
					*cp_M++ = str_tmp[i];
				}
			}
		} else if (*cp == '(') {
			cnt_bracket++;
			if (f_isPlus) {
				*cp_P++ = *cp++;
			} else {
				*cp_M++ = *cp++;
			}
			for (;;) {
				if (*cp == ' ' || *cp == '\t' || *cp == '\r' || *cp == '\n') {
					cp++;
					continue;
				} else if (*cp == '(') {
					cnt_bracket++;
				} else if (*cp == ')') {
					cnt_bracket--;
				}
				if (f_isPlus) {
					*cp_P++ = *cp++;
				} else {
					*cp_M++ = *cp++;
				}
				if (cnt_bracket == 0) break;
			}
		} else if (*cp == '+') {
			f_isPlus = true;
			cp++;
			if (cp_P != str_plus) *cp_P++ = '+';
		} else if (*cp == '-') {
			f_isPlus = false;
			cp++;
			if (cp_M != str_minus) *cp_M++ = '+';
		} else {
			if (f_isPlus) {
				*cp_P++ = *cp++;
			} else {
				*cp_M++ = *cp++;
			}
		}
	}

	if (cnt_bracket != 0) {
		log_sys("#  Unbalanced bracket.\n");
		goto err;
	}

	*cp_P = *cp_M = '\0';

	return 0;

err:
	log_sys("## Error in separate_terms. \n");
	return -1;

}

/*---------------------- write_S_usrfunc -------------------------------------------
 *
 *	S-systemΥ桼ؿ񤭽Ф
 *
 */
static int
write_S_usrfunc(FILE *fp_out)
{
	if (Write_header(fp_out, true)) goto err;

	fprintf(fp_out,"\n#include \"life.h\"\n\n");

	/* fvec ν񤭽Ф */
	fprintf(fp_out,"void usr_fvec(double fvec[], double y[], ");
	fprintf(fp_out,"double Gene, Parameter *p)\n{\n");

	if (write_S_funcs(fp_out, FNAME_SV)) goto err;

	fprintf(fp_out,"}\n\n");
	
	/* fjac ν񤭽Ф */
	fprintf(fp_out,"void usr_fjac(double fjac[][MAX_VAR_NUM], double y[], ");
	fprintf(fp_out,"double Gene, Parameter *p)\n{\n");

	if (write_S_funcs(fp_out, FNAME_SJ)) goto err;

	fprintf(fp_out,"}\n");

	return 0;

err:
	log_sys("## Error in write_S_usrfunc.\n");
	return -1;
}

/*---------------------- write_S_funcs -------------------------------------------
 *
 *	S-systemѤδؿʬ
 *
 */
static int
write_S_funcs(FILE *fp_out, char *fname)
{
	char tline[BUFFSIZE];
	FILE *fp_in;

	fprintf(fp_out, "\tdouble *%s\t= p->val[1];\n", CONSTANT_PLAYER);
	fprintf(fp_out, "\tdouble *kplus\t= p->val[2];\n");
	fprintf(fp_out, "\tdouble *kminus\t= p->val[3];\n");
	fprintf(fp_out, "\tdouble *g\t= p->val[4];\n");
	fprintf(fp_out, "\tdouble *h\t= p->val[5];\n\n");

	if((fp_in = fopen(fname, "r")) == NULL){
		log_sys("#  Cannot open %s\n", fname);
		goto err;
	}
	
	while (fgets(tline, sizeof tline, fp_in)) {
		fprintf(fp_out, "\t%s", tline);
	}

	fclose(fp_in);

	return 0;

err:
	log_sys("## Error in write_S_funcs.\n");
	return -1;
}

/*---------------------- write_GEhead -------------------------------------------
 *
 *	g,h preؿΥإåʬ񤯡
 *
 */
static int
write_GEhead(FILE *fp_out, ParamBase_T *param_base, int n_param, int n_var, int n_const)
{
	if (Write_header(fp_out, true)) goto err;

	fprintf(fp_out,"\n#include \"life.h\"\n\n");
	fprintf(fp_out,"void get_GHdata(double **gd, double **gi,");
	fprintf(fp_out," double **hd, double **hi,\n");
	fprintf(fp_out,"\tdouble *v_plus, double *v_minus, double *y, Parameter *p)\n{\n");

	/* ѥѥ᡼٥ν񤭽Ф*/
	Write_param_label(param_base, n_param, fp_out);

	fprintf(fp_out,"\n");

	return 0;

err:
	log_sys("## Error in write_GEhead.\n");
	return -1;
}

/*---------------------- write_GEtail -------------------------------------------
 *
 *	g,h preؿνλӸĿؿ񤯡
 *
 */
static void
write_GEtail(FILE *fp_out, int n_var, int n_const)
{

	fprintf(fp_out,"}\n\n\n");
	fprintf(fp_out,"void get_GHnum(int *n_var, int *n_const)\n{\n");
	fprintf(fp_out,"\t*n_var = %d;\n", n_var);
	fprintf(fp_out,"\t*n_const = %d;\n", n_const);
	fprintf(fp_out,"}\n");
}

/*---------------------- write_Sfjac -------------------------------------------
 *
 *	S-systemfjac񤭽Ф
 *
 */
static void
write_Sfjac(FILE *fp_out, int n_var, int n_const, char *label, int *flag, int index)
{
	int i;
	char str_target[BUFFSIZE];

	for (i=1; i<=n_var; i++) {
		if (flag[i]) {
			sprintf(str_target, "y[%d]", i);
			if (i == index) {
				fprintf(fp_out, "*%s[%d]*pow(%s,%s[%d]-1)",
							   	label, flag[i], str_target, label, flag[i]);
			} else {
				fprintf(fp_out, "*pow(%s,%s[%d])", str_target, label, flag[i]);
			}
		}
	}
	for (i=1; i<=n_const; i++) {
		if (flag[n_var+i]) {
			sprintf(str_target, "%s[%d]", CONSTANT_PLAYER, i);
			fprintf(fp_out, "*pow(%s,%s[%d])", str_target, label, flag[n_var+i]);
		}
	}
}

/*---------------------- write_Sfvec -------------------------------------------
 *
 *	S-systemfvec񤭽Ф
 *
 */
static void
write_Sfvec(FILE *fp_out, int n_var, int n_const,  char *label, int *flag)
{
	int i;
	char str_target[BUFFSIZE];
	
	for (i=1; i<=n_var; i++) {
		if (flag[i]) {
			sprintf(str_target, "y[%d]", i);
			fprintf(fp_out, "*pow(%s,%s[%d])", str_target, label, flag[i]);
		}
	}
	for (i=1; i<=n_const; i++) {
		if (flag[n_var+i]) {
			sprintf(str_target, "%s[%d]", CONSTANT_PLAYER, i);
			fprintf(fp_out, "*pow(%s,%s[%d])", str_target, label, flag[n_var+i]);
		}
	}
}
