/*
 * "R & B": Real-coded GAs & Bit-string GAs
 *
 * Interface to Life Simulator
 */
#ifndef _LS_INTERFACE_H_
#define _LS_INTERFACE_H_

extern int AllocSolutionMatrix();

extern void FreeSolutionMatrix();

extern void PreserveDefaultLsParam(double t_start, double t_end, double h, double dt_save, double *y);

extern int LsFitness(const double *x, int num_variable, int argc, char **argv, double *fitness);

#endif /* _LS_INTERFACE_H_ */
