#include <stdlib.h>
#include <string.h>

#include "randb.h"
#include "utl_arg.h"
#include "logUtil.h"

int CopyArgv(int argc, char **argv, char **cargv)
{
	int i;
	int	rv = EXIT_ERROR;

	for(i = 0; i < argc; i++){
		cargv[i] = NULL;
	}
	for(i = 0; i < argc; i++){
		if((cargv[i] = strdup(argv[i])) == NULL){
			log_sys(" ## Error: strdup(In CopyArgv).\n");
			goto out;
		}
	}

	rv = EXIT_NORMAL;
out:

	return rv;
}

void FreeCargv(int argc, char **cargv)
{
	int i;

	for(i = 0; i < argc; i++){
		if(cargv[i] != NULL) free(cargv[i]);
	}
}


