/***********************************************************************
 *
 *     ̿ߥ졼
 *
 *         Java Class (JReaction)
 *
 ***********************************************************************/

package jp.co.suri.lifesim;
import java.io.Serializable;
public class JReaction implements Serializable, Cloneable {
	public JReaction(){}
	public Object clone() throws CloneNotSupportedException {
		/* Only Shallow Copy */
		return super.clone();
	}
	public static final int REACTION_REACTIONTYPE_NONE = 0;	
	public static final int REACTION_REACTIONTYPE_BINDING = 1;	
	public static final int REACTION_REACTIONTYPE_BINDING_WITH_STOICHIOMETRIC_CHANGES = 2;	
	public static final int REACTION_REACTIONTYPE_HOMO_ASSOCIATION_OR_MODIFICATION = 3;	
	public static final int REACTION_REACTIONTYPE_HOMO_ASSOCIATION_OR_MODIFICATION_WITH_STOICHIOMETRIC_CHANGES = 4;	
	public static final int REACTION_REACTIONTYPE_ELIMINATION = 5;	
	public static final int REACTION_REACTIONTYPE_ELIMINATION_WITH_STOICHIOMETRIC_CHANGES = 6;	
	public static final int REACTION_REACTIONTYPE_REVERSIBLE_CONVERSION = 7;	
	public static final int REACTION_REACTIONTYPE_IRREVERSIBLE_CONVERSION = 8;	
	public static final int REACTION_REACTIONTYPE_REVERSIBLE_CONVERSION_REGARDING_MULTICOMPONENT = 9;	
	public static final int REACTION_REACTIONTYPE_IRREVERSIBLE_CONVERSION_REGARDING_MULTICOMPONENT = 10;	
	public static final int REACTION_REACTIONTYPE_TRANSPORT = 11;	
	public static final int REACTION_REACTIONTYPE_OPTION_TRANSPORT = 12;	
	public static final int REACTION_REACTIONTYPE_TRANSCRIPTION = 13;	
	public static final int REACTION_REACTIONTYPE_TRANSLATION = 14;	
	public static final int REACTION_REACTIONTYPE_DEGRADATION = 15;	
	/* isConvertible -> JModelPack (true/false) */
	public int			reactionID;
	public int			groupID;
	public int			reactionType;
	public int			isConvertible;
	public String			modifierReactionEquation;	
	public int			listOfReactants_n;
	public	JListOfReactants listOfReactants[];
	public int			listOfProducts_n;
	public	JListOfProducts listOfProducts[];
	public int			listOfModifiers_n;
	public	JListOfModifiers listOfModifiers[];
	public int			modifierComplex_n;
	public	JModifierComplex modifierComplex[];
}
