/*
 * Utility of memory allocation
 *
 * utl_alloc.h
 */
#ifndef _UTL_ALLOC_H_
#define _UTL_ALLOC_H_

/*
 * Prottype declarations of a function
 */

/*-----
 * IntVectorAllocؿ
 * 	ǻꤵ줿礭int
 * 	ΰݤƬΥݥ󥿤֤
 */
extern int *IntVectorAlloc(int vector_size);

/*-----
 * FreeGaGeneVectorؿ
 * 	ǻꤵ줿ΰ
 */
extern void FreeIntVector(int *int_vector);

/*-----
 * IntMatrixAllocؿ
 * 	ǻꤵ줿礭intι
 * 	ΰݤƬΥݥ󥿤֤
 */
extern int **IntMatrixAlloc(int num_row, int num_col);

/*-----
 * FreeIntMatrixؿ
 * 	ǻꤵ줿ΰ
 */
extern void FreeIntMatrix(int **int_mat);


/*-----
 * DoubleVectorAllocؿ
 * 	ǻꤵ줿礭GaGene_T
 * 	ΰݤƬΥݥ󥿤֤
 */
extern double *DoubleVectorAlloc(int vector_size);

/*-----
 * FreeDoubleVectorؿ
 * 	ǻꤵ줿ΰ
 */
extern void FreeDoubleVector(double *island);

/*-----
 * DoubleMatrixAllocؿ
 * 	ǻꤵ줿礭GaGene_Tι
 * 	ΰݤƬΥݥ󥿤֤
 */
extern double **DoubleMatrixAlloc(int num_row, int num_col);

/*-----
 * FreeDoubleMatrixؿ
 * 	ǻꤵ줿ΰ
 */
extern void FreeDoubleMatrix(double **double_mat);

#endif /* _UTL_ALLOC_H_ */

