//  ΥեNewton-RaphsonˡˤϢΩ򤯤Ȥ˴Ϣ
// ؿƤ롣
//  ƤӽФΤ CheckNRparamSetNRparamSolveAlgebraicEq 
// 3ĤǤ롣
//  ʲοޤϤΥե줿ؿδ֤δطˤĤƼΤǤ롣
// usr_algebraicEq Τߤϥ桼ؿǤꡢ¾Υե롣
//
// SolveSTDbyNR 	롣
//   + SetNRparam 	 	򻲾
//   + checkNRresult 	򻲾
//   
// SetNRparam 		ParamTParamδ֤ͤۤʤäƤŪ˶ŤƥåȤ롣
//   + setOneNRparam 	:嵭1Υѥ᡼˴ؤƼ¹Ԥ롣
//       + changeNRparam 	嵭1ļΥѥ᡼˴ؤƼ¹Ԥ롣
//           + getIterationTimes 	롣
//           + checkNRresult 		򻲾
//          
// CheckNRparam 2ʬΥȯŸѥ᡼TimeEventѹƤ뤫ݤĴ٤롣
//   + SetNRparam 	
// 
// SolveAlgebraicEq 2ʬΥȯŸ굡ŪϢΩ򤯡򤱤ʤä
//   + 				  ȤƤyͤŪ˶ŤƲ򤭤ʤ
//   + checkNRresult 	  
//   + getIterationTimes	 
//   
// checkNRresult 	򤤤̤ͤäƤʤɤå롣
//   + solveNewtonRaphson	Newton-RaphsonС 
//       + usr_algebraicEq	桼ؿ()
//       + ludcmp 	LUʬ
//       + lubksb 	LU
//      
#include "life.h"
#include "nr_lu.h"

// ®ΤϥեstaticȤ롣
#if 0
static double vv[MAX_VAR_NUM];
#endif
static int indx[MAX_VAR_NUM];
static double fvec[MAX_VAR_NUM],fjac[MAX_VAR_NUM][MAX_VAR_NUM],p[MAX_VAR_NUM];
	
// եstaticؿΥץȥ
static int setOneNRparam(double y[], double tg[], double curr[], int n, char *cparam);
static int changeNRparam(double *param, double *param_pre, double y[]);
static int getIterationTimes(double tg_value, double pre_value, double *factor);
static int checkNRresult(double y[]);
static int solveNewtonRaphson(int ntrial, double y[], int n, double tolx, double tolf);
static void lubksb(double a[][MAX_VAR_NUM], int n, int *indx, double b[]);
static void ludcmp(double a[][MAX_VAR_NUM], int n, int *indx, double *d);
static int cal_sens(double y[], double y_pre[], double *param, double *paramP, int n_param, char *pname);

//----------------SolveSTDbyNR------------------------------------------
//
// 	NewtonRaphsonˡϢΩ򤯡
//
//	I:y, y_pre (ХȤParamParamTParamP)
//	O:y, y_pre (ХȤParamParamTParamP)
//	꥿͡(0)(-1)
//
int SolveSTDbyNR(double y[], double y_pre[])
{
	int i;

	// ѥ᡼ѤäƤŪѲľ
	if (SetNRparam(y)) {	// Ԥ
		Param = ParamP;	// ѥ᡼ͤᤷƤ
#ifdef DBG
		for (i=1; i<=Param.n_var; i++)
			DBGW(0, ("y[%d]=%10.3E\n", i, y[i]/GeneConc));
#endif
		// yͤͤᤷƤ
		for (i=1; i<=Param.n_var; i++) y[i] = y_pre[i];
		return -1;
	}

	Param = ParamT;	// ʲǲ򤯻Υѥ᡼ͤɸͤ˥åȤ
			// ºݤˤϾνǤۤParamTͤǲ򤱤Ƥ
	
	// Τʥѥ᡼ͤǲľ
	if (checkNRresult(y)) {	// 򤬵ޤʤޤβ򤬵ޤä
		Param = ParamP;	// ѥ᡼ͤᤷƤ
#ifdef DBG
		for (i=1; i<=Param.n_var; i++)
			DBGW(0, ("y[%d]=%10.3E\n", i, y[i]/GeneConc));
#endif
		// yͤͤᤷƤ
		for (i=1; i<=Param.n_var; i++) y[i] = y_pre[i];
		return -1;
	}
	
	// Τ˸ߤͤParamPy_pre˳Ǽ
	ParamP = Param;
	for (i=1; i<=Param.n_var; i++) y_pre[i] = y[i];

	return 0;
}

//----------------SetNRparam------------------------------------------
//
// 	ѥ᡼ѹ줿ŪͤŤƲľ
//
//	I:y (ХȤParamParamT)
//	O:y (ХȤParam)
//	꥿͡(0)(-1)
//
int SetNRparam(double y[])
{
	int	i;
	char	*name = NULL;
	for( i = 1 ; i <= getParamNum() ; i++ ){
		name = Pno2Name(i);
		if( name == NULL ){
			log_sys("## Cannot get Param Name Pno[%d].\n", i);
			return -1;
		}
		if (setOneNRparam(y, ParamT.val[i], Param.val[i], Param.n_val[i], name)) {
			log_sys("## Cannot set %s.\n", name);
			return -1;
		}
	}

	return 0;
}

//----------------setOneNRparam------------------------------------------
//
// 	ѥ᡼ѹ줿ŪͤŤƲľ(1Υѥ᡼ˤĤ)
//
//	I:y, tg, curr, n, cparam
//	O:y, curr
//	꥿͡(0)(-1)
//
static int setOneNRparam(double y[], double tg[], double curr[], int n, char *cparam)
{
	int i;

	for(i=1; i<=n; i++) {	// ǥåΥ롼
		if(tg[i] != curr[i]) {	// ͤäƤ
#ifdef DBG
			DBGW(0, ("change %s[%3d] %10.3E to %10.3E ",
						cparam, i, curr[i], tg[i]));
#endif
			if(changeNRparam(&tg[i], &curr[i], y)) {
				log_sys("## Cannot set No.%d :%e to %e\n",
							i, curr[i], tg[i]);
				return -1;
			}
		}
	}
	return 0;
}

//----------------changeNRparam------------------------------------------
//
// 	ѹ줿ѥ᡼Ū˶ŤƲľ(1ĤΥѥ᡼ˤĤ)
//
//	I:y, param, param_pre
//	O:y, param_pre
//	꥿͡(0)(-1)
//
static int changeNRparam(double *param, double *param_pre, double y[])
{
	int i, n_iteration;
	double factor;

	if (*param > TINY && *param_pre > TINY) {	// ξͤȤ̾ΤΤǤ
		// ŪͤѲβ
		n_iteration = getIterationTimes(*param, *param_pre, &factor);
#ifdef DBG
		DBGW(0, ("Iteration=%d, factor=%10.3E\n", n_iteration, factor));
#endif

		// ͤŪ˶ŤϢΩľ
		for(i=0; i<n_iteration; i++){
			*param_pre *= factor;

			/*
			 * ѥ᡼ǤβΥåϤʤ '2002.11.20
			 * if(checkNRresult(y)) return -1;
			 */
			if(solveNewtonRaphson(Nr_trial, y, Param.n_varNR, Nr_tol_x, Nr_tol_f)) return -1;
		}
	} else {	// 줤줫ͤξ
		// ŪͤѲβ
		n_iteration = (int)(log(fabs(*param - *param_pre))*10.0);
	       	n_iteration = (n_iteration > 1) ? n_iteration : 1;
		factor = (*param - *param_pre)/n_iteration;
#ifdef DBG
		DBGW(0, ("Iteration=%d, width=%10.3E\n", n_iteration, factor));
#endif

		// ͤŪ˶ŤϢΩľ
		for(i=0; i<n_iteration; i++){
			*param_pre += factor;

			/*
			 * ѥ᡼ǤβΥåϤʤ '2002.11.20
			 * if(checkNRresult(y)) return -1;
			 */
			if(solveNewtonRaphson(Nr_trial, y, Param.n_varNR, Nr_tol_x, Nr_tol_f)) return -1;
		}
	}
	return 0;
}

//----------------CheckNRparam------------------------------------------
//
// 	2ʬΥλȯŸξ硢।٥Ȥˤѥ᡼ѹƤʤɤ
// Ĵ١⤷ѹƤԤäƲľ
// ŪˤSetNRparamǤ뤬ȯŸΤΤνԤ
//
//	I:y, y_pre (ХȤParamParamP)
//	O:y, y_pre (ХȤParamParamTParamP)
//	꥿͡(0)(-1)
//
int CheckNRparam(double y[])
{
	// SetNRparamѤ뤿
	ParamT = Param;
	Param  = ParamP;

	// ¹
	if (SetNRparam(y)) return -1;

	ParamP = Param;	// Τ˸ߤͤParamP˳Ǽ
	return 0;
}

//----------------SolveAlgebraicEq------------------------------------------
//
// 	2ʬΥλȯŸξ硢ʬ¦ѹ줿yϢΩ
// ȤƴͿ뤿ᡢޤ굡ŪˤΤޤ޲򤤤Ƥߤ롣
//  ȤƤyͤѲ礭˲򤱤ʤͤѤ
// ŪͤŤƽ򤹤롣
//  ºݤˤʬβ򤬤礭ѲȤϹͤ줺ɬפʤΤ
// ।٥ȤȤyͤ礭ѹ줿
//
//	I:y, y_pre (ХȤParam)
//	O:y, y_pre
//	꥿͡(0)(-1)cdataǿ
//
int SolveAlgebraicEq(double y[], double y_pre[])
{
	int i, j, n_iteration, cnt=0;
	double factor;

	if(checkNRresult(y)) {	// 굡Ū˲򤤤Ʋ򤱤ʤä
		for(i=1+Param.n_varNR; i<=Param.n_var; i++) {	// ʬ¦ѿyΥ롼
			if (y[i] != y_pre[i]) {	// ͤۤʤäƤ

				cnt++;	// ۤʤäy Υ
				// ˤľ
				if (y[i]>TINY && y_pre[i]>TINY) {	// ξͤȤ̾ΤΤξ

					// ŪͤŤβ
					n_iteration = getIterationTimes(y[i], y_pre[i], &factor);
#ifdef DBG
					DBGW(0, ("Change y[%d]=%10.3E to %10.3E, ", i, y_pre[i], y[i]));
					DBGW(0, ("Iteration=%d, factor=%10.3E\n", n_iteration, factor));
#endif
					// ŪͤŤϢΩľ
					for(j=1; j<=n_iteration; ++j){
						y_pre[i] *= factor;
						if(checkNRresult(y_pre)) {
#ifdef DBG
							DBGW(0, ("## y[%d] is wrong :%e\n",i,y[i]));
#endif
							log_sys("## Cannot set y[%d] to %e\n",i,y[i]);
							return -1;
						}
					}
				} else {	// 줤줫⤷ξޤξ

					// ŪͤŤβ
        			n_iteration = (int)(log(fabs(y[i] - y_pre[i]))*10.0);
        			n_iteration = (n_iteration > 1) ? n_iteration : 1;
					factor = (y[i] - y_pre[i])/n_iteration;
#ifdef DBG
					DBGW(0, ("Change y[%d]=%10.3E to %10.3E, ", i, y_pre[i], y[i]));
					DBGW(0, ("Iteration=%d, width=%10.3E\n", n_iteration, factor));
#endif
					// ŪͤŤϢΩľ
					for(j=1; j<=n_iteration; ++j){
						y_pre[i] += factor;
						if(checkNRresult(y_pre)) {
#ifdef DBG
							DBGW(0, ("## y[%d] is wrong :%e\n",i,y[i]));
#endif
							log_sys("## Cannot set y[%d] to %e\n",i,y[i]);
							return -1;
						}
					}
				}
			}
		}

		if (cnt==0) {	// ǽ˲򤱤ʤäΤѹ٤ y ʤȤȤ
				// ǽ餫ʬ򤱤ƤʤȤȤǤ
			log_sys("## Cannot solve Algebraic Eq. at start point.\n");
			return -1;
		}

		// ˤ򤱤ͤy˥åȤ
		for(i=1; i<=Param.n_varNR; i++) y[i] = y_pre[i];
	}
#ifdef DBG
		for (i=1; i<=Param.n_var; i++) 
			DBGW(5,("inEQ:y[%2d]=%10.3E,%10.3E,%10.3E\n", i, y[i], y_pre[i], y[i]/y_pre[i]));
#endif

	// Τ˸ߤͤy_pre˳Ǽ
	for(i=1; i<=Param.n_var; i++) y_pre[i] = y[i];
	return 0;
}

//----------------getIterationTimes------------------------------------------
//
//  ŪԤ롣
//
//	I:tg_value, pre_value
//	O:factor
//	꥿͡(n_iteration)
//
static int getIterationTimes(double tg_value, double pre_value, double *factor)
{
	double ratio, c_ratio=Nr_ratio;
	int n_iteration;

	if (tg_value <= TINY || pre_value <= TINY) exit(-1);
	
	ratio = tg_value/pre_value;
	n_iteration = (int)(fabs(log(ratio))/log(c_ratio)) + 1;
	*factor = pow(ratio, 1.0/n_iteration);

	return n_iteration;
}

//----------------checkNRresult------------------------------------------
//
//  ϢΩNewton-Raphsonˡˤ򤤤Ƥβͤ
// 򤱤Ƥ뤫ݤĴ٤롣
//
//	I:y (ХȤParam)
//	O:y
//	꥿͡(0)(-1)
//
static int checkNRresult(double y[])
{
#if 1
	int i;
#endif

	if (solveNewtonRaphson(Nr_trial, y, Param.n_varNR, Nr_tol_x, Nr_tol_f)) return -1;

#if 1
	for(i=1;i<=Param.n_varNR;++i) {
		if(y[i] < 0.0) {
			log_sys("## Get negative solution in checkNRresult. y[%d]=%10.3E\n", i, y[i]);
			return -1;
		}
	}
#endif
	
	return 0;
}

//----------------solveNewtonRaphson------------------------------------------
//
//  ϢΩNewton-Raphsonˡˤ򤯡
//
//	I:y (ХȤParam)
//	O:y
//	꥿͡(0)
// 				(-1ǲ򤱤ʤä1򤱤ƤʤΤ˲Ѳʤʤä)
//
static int solveNewtonRaphson(int ntrial, double y[], int n, double tolx, double tolf)
{
	int i, j, k;
	//static int indx[MAX_VAR_NUM];
	double d,errf=0.0,errx=0.0;
	//static double fvec[MAX_VAR_NUM],fjac[MAX_VAR_NUM][MAX_VAR_NUM],p[MAX_VAR_NUM];

	for (k=1;k<=ntrial;k++) {	// ֤׻Υ롼
		for (j=1;j<=Param.n_varNR;j++) {
			for (i=1;i<=Param.n_varNR;i++) {
				fjac[j][i] = 0.0;
			}
		}
		/* usr_algebraicEq(y,fvec,fjac,GeneConc,&Param); */
		usr_fvec(fvec,y,GeneConc,&Param);
		usr_fjac(fjac,y,GeneConc,&Param);
		errf=0.0;
		for (i=1;i<=n;i++) errf += fabs(fvec[i]);
		if (errf <= tolf) {	// ؿμ«
			return 0;
		}
		for (i=1;i<=n;i++) p[i] = -fvec[i];
		ludcmp(fjac,n,indx,&d);
		lubksb(fjac,n,indx,p);
		errx=0.0;
		for (i=1;i<=n;i++) {
			errx += fabs(p[i]);
			y[i] += p[i];
		}
		if (errx <= tolx) {	// ѿμ«?
			//log_sys("## Cannot solve in solveNewtonRaphson.  Err =%10.3E Errx =%10.3E n=%3d\n", errf, errx, k);
			return 0;
		}
#ifdef DBG
		DBGW(10, ("Errf =%10.3E Errx =%10.3E n=%3d\n", errf, errx, k));
#endif
	}	// ֤׻Υ롼פν
	
	// β֤Ƥ򤱤ʤ
	log_sys("## Not converged in solveNewtonRaphson. in %3d times.\n", ntrial);
	log_sys("	Errf =%10.3E Errx =%10.3E\n", errf, errx);
	return -1;
}

//----------------ludcmp------------------------------------------
//
//  LUʬ
//
//	I:a, n, indx
//	O:a, indx, d
//	꥿͡ʤ
//
static void ludcmp(double a[][MAX_VAR_NUM], int n, int *indx, double *d)
{
	int	i;
	double	*aa[MAX_VAR_NUM];

	memset(aa, 0, sizeof(double *) * MAX_VAR_NUM);
	for( i = 1 ; i <= n ; i++ ){
		aa[i] = &a[i][0];
	}

	nr_ludcmp(aa, n, indx, d);
}

//----------------lubksb------------------------------------------
//
//  LU
//
//	I:a, n, indx, b
//	O:b
//	꥿͡ʤ
//
static void lubksb(double a[][MAX_VAR_NUM], int n, int *indx, double b[])
{
	int	i;
	double	*aa[MAX_VAR_NUM];

	memset(aa, 0, sizeof(double *) * MAX_VAR_NUM);
	for( i = 1 ; i <= n ; i++ ){
		aa[i] = &a[i][0];
	}

	nr_lubksb(aa, n, indx, b);
}

//----------------Sensitivity------------------------------------------
//
//  ѥ᡼ѲФ̤ư롣
//	Υ롼ǤϤ٤ƤΥѥ᡼ФƼ·׻롼cal_sens
// 	ƤӽФƤ롣
//
//	I:y, y_pre
//	O:ʤ
//	꥿͡(0)(-1)
//
int Sensitivity(double y[], double y_pre[])
{
	//char pname[MAX_LINE];
	int	i;
	char	*name = NULL;
	
	fprintf(Fp_out, "\n\n$$ Sensitivity\n");

	for( i = 1 ; i <= getParamNum() ; i++ ){
		if (Param.n_val[i]) {
			name = Pno2Name(i);
			if( name == NULL ){
				log_sys("## Cannot get Param Name Pno[%d].\n", i);
				return -1;
			}
			if (cal_sens(y, y_pre, Param.val[i], ParamP.val[i], Param.n_val[i], name)) {
				return -1;
			}
		}
	}

	return 0;
}

//----------------cal_sens------------------------------------------
//
//  ƥѥ᡼ȤͤȤͤ鷺ˤ餷Ѳ
//	ľܽϥե˽񤭽Ф
//
//	Ѳ̤ϥѥ᡼ͤ d_ratio(Nr_sens_cw) ݤ͡
//		delta = param * d_ratio
//	äƥѥ᡼ͤ 0 ξϷ׻Ԥʤ
//
//	η׻
//		 = (V(param + delta) - V(param)) / delta 	롣
//
//
//	I:y, y_pre, param, paramP, n_param, pname
//	O:ʤ
//	꥿͡(0)(-1)
//
static int cal_sens(double y[], double y_pre[], double *param, double *paramP, int n_param, char *pname)
{
	int i, j;
	static int	param_cnt=0;
	char my_name[MAX_LINE];
	double tg, delta, d_ratio = Nr_sens_cw, denomi = log(1.0 + Nr_sens_cw);
	
	for (i=1; i<=n_param; i++) {
		if (param[i]) {	// ѥ᡼ͤ 0 ʳΤȤ
			for (j=1; j<=Param.n_var; j++) y[j] = y_pre[j];
			delta = param[i] * d_ratio;
			tg = param[i] + delta;
		    if (changeNRparam(&tg, &param[i], y)) {
		        log_sys("## Cannot set kx.\n");
		        return -1;
		    }
			param_cnt++;
			sprintf(my_name, "%s[%3d]", pname, i);
			fprintf(Fp_out, "%4d: %-12s", param_cnt, my_name);
			for (j=1; j<=Param.n_var; j++) {
				fprintf(Fp_out, ", %12.3E", log(y[j]/y_pre[j])/denomi);
			}
			fprintf(Fp_out, "\n");
			param[i] = paramP[i];
		}
	}
	return 0;
}
