//  MathResultTime.txtMathVarName.txtɤ߹ǥեС
//	Ԥ
//	
//	makeGraphData -IMathResultTime.txt -VMathVarName.txt [-d*]
//
//	ϥեϰʲ̤ꡣ
//	graphSurbey.txt	ѥ᡼٥⡢ΤͤΥꥹ
//	graphInfo_N.txt	ѿκ͡Ǿ͡ư̾ΤΥꥹ
//	graphData_N.txt	ǡե롢1ܤѿοȥǡԿӥ٥
//
//	ѥ᡼٥ǤʤgraphSurbey.txt϶_N  _1 
//	ѥ᡼٥λ_N ϥեΥꥢֹ档׻ｪλ
//	ˤĤƤϤʤΤǥѥ᡼٥ֹȤɬפʤ	
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

// 顼ؿ
#include "logUtil.h"

// Ƽﵬ
#define MAX_LINE 2096		// ϥǡɤ߹߻κ
#define MAX_VAR_NUM 500		// ѿκ󥵥
#define FNAME_V "graphVar.txt"
#define FNAME_S "graphSurvey.txt"
#define FNAME_U "graphInfo"
#define FNAME_D "graphData"
#define FNAME_T "graphTMP.txt"

// եstaticؿΥץȥ
static void getSurveyStr(char *tline, char *aline);
static int getData(double var[], char *tline);

//----------------main------------------------------------------
//
int main(int argc, char *argv[])
{
	int i, n_var, n_var_d=0, f_survey=0, cnt_d, cnt_o=0, cnt_f=0;
	char sline[MAX_LINE], tline[MAX_LINE], str_survey[MAX_LINE];
	char fname_i[FILENAME_MAX];
	char fname_v[FILENAME_MAX];
	char fname_s[FILENAME_MAX];
	char fname_u[FILENAME_MAX];
	char fname_d[FILENAME_MAX];
	char fname_t[FILENAME_MAX];
	FILE *fp_i=NULL, *fp_v, *fp_s, *fp_u, *fp_d, *fp_t;
	char *y_name[MAX_VAR_NUM];
	double y[MAX_VAR_NUM], y_max[MAX_VAR_NUM], y_min[MAX_VAR_NUM], y_width[MAX_VAR_NUM];
	
	strcpy(str_survey, "\0");

#ifdef DBG
	// open debug-log file.
	if(log_dbginit(argc, argv)) {
		printf("Cannot open dbgLog file!!");
		goto	err;
	}
#endif

	// open sys-log file.
	if(log_sysinit(argc, argv)) {
		printf("Cannot open sysLog file!!");
		goto	err;
	}

	// ץβ
	for (i = 0; i < argc; i++) {
		if (argv[i][0] == '-') {
			switch (argv[i][1]) {
			case 'I':
				cnt_o++;
				strcpy(fname_i, &argv[i][2]);
				break;
			case 'V':
				cnt_o++;
				strcpy(fname_v, &argv[i][2]);
				break;
			case 'd':
				break;
			default:
				log_sys("ERROR!! invalid argument !!\n");
				goto	err;
			}
		}
	}
	if (cnt_o != 2) {
		log_sys("ERROR!! This program needs 2 input files. But now it has %d file(s).\n", cnt_o);
		goto	err;
	}

	// ¾Υե̾
	strcpy(fname_s, FNAME_S);
	strcpy(fname_t, FNAME_T);
	
	// ѿ̾ե򥪡ץ󤷥ǡɤ߹
	if((fp_v = fopen(fname_v, "r")) == NULL){
		log_sys("ERROR!! Cannot open %s\n", fname_v);
		goto	err;
	}
	while(fgets(sline, sizeof sline, fp_v)) {
		sscanf(sline, "%d,%s", &i, tline);
		y_name[i] = strdup(tline);
	}
	n_var = i;
	fclose(fp_v);

	// y_max, y_min νå
	for (i=1; i<=n_var; i++) {
		y_max[i] = -1.0E-99;
		y_min[i] =  1.0E+99;
	}
	
	// ѥ᡼٥ե򥪡ץ󤹤
	if((fp_s = fopen(fname_s, "w")) == NULL){
		log_sys("ERROR!! Cannot open %s\n", fname_s);
		goto	err;
	}
	
	// ϥե򥪡ץ󤹤
	if((fp_i = fopen(fname_i, "r")) == NULL){
		log_sys("ERROR!! Cannot open %s\n", fname_i);
		goto	err;
	}

	// ϥեɹ롼
	while(fgets(sline, sizeof sline, fp_i)) {
		if (strncmp(sline, "$$ PARAM", 8) == 0) {
			f_survey = 1;
			getSurveyStr(sline, str_survey);
		}
		if (strncmp(sline, "Time", 4) == 0) {	// Time ʹߤιԤǡ
			// ƥݥե񤭹Ѥ˥ץ󤹤
			if((fp_t = fopen(fname_t, "w")) == NULL){
				log_sys("ERROR!! Cannot open %s\n", fname_t);
				goto	err;
			}
			
			// ǡɤ߹ߥ롼
			cnt_d = 0;	// ǡԿ󥿤Υꥻå
			while(fgets(sline, sizeof sline, fp_i)) {

				// ǡԤμ
				if (strncmp(sline, "$$ Finish", 9) == 0) {	// ׻
					cnt_f++; // ξϽϥեֹ򥫥ȥå
					// ٥ǡν񤭹
					if (f_survey) fprintf(fp_s, "%s\n", str_survey);
					fclose(fp_t);	// ƥݥեΥ
					// ƥݥեɤ߼ѤȤƥץ
					if((fp_t = fopen(fname_t, "r")) == NULL){
						log_sys("ERROR!! Cannot open %s\n", fname_t);
						goto	err;
					}
					// եǡե򥪡ץ󡢽񤭹
					sprintf(fname_u, "%s_%d.txt", FNAME_U, cnt_f);
					sprintf(fname_d, "%s_%d.txt", FNAME_D, cnt_f);
					if((fp_u = fopen(fname_u, "w")) == NULL){
						log_sys("ERROR!! Cannot open %s\n", fname_u);
						goto	err;
					}
					if((fp_d = fopen(fname_d, "w")) == NULL){
						log_sys("ERROR!! Cannot open %s\n", fname_d);
						goto	err;
					}
					fprintf(fp_d, "%d\t%d\t%s\n", n_var, cnt_d, str_survey);

					// ƥݥǡեɤ߹ߥ롼
					while(fgets(tline, sizeof tline, fp_t)) {
						n_var_d = getData(y, tline) - 1;
						fprintf(fp_d, "%s", tline);	// եǡեؤν񤭹
						for (i=1; i<=n_var; i++) {	// Ǿ
							if (y[i] > y_max[i]) y_max[i] = y[i];
							if (y[i] < y_min[i]) y_min[i] = y[i];
						}
					}	// ƥݥǡեɹ end-while
					
					// ѿ̾եѿο(n_var)ɤ߹ǡοˤå
					if (n_var_d != n_var) {
						log_sys("### Not match number of variables ");
						log_sys("between 'graphVar.txt' and ResultFile.\n");
						log_sys("	%d vs %d at %s\n", n_var, n_var_d, str_survey);
					}

					// վեؤν
					fprintf(fp_u, "variable   maximum     minimum   diff(%s) name\n", "%");
					fprintf(fp_u, "=====================================================\n");
					for (i=1; i<=n_var; i++) {
						if (y_max[i] == 0.0 && y_min[i] == 0.0) {
							y_width[i] = 0.0;
						} else {
							y_width[i] = 100.0*(y_max[i]-y_min[i])
								/(fabs(y_max[i])>fabs(y_min[i]) ? y_max[i] : y_min[i]);
						}
						fprintf(fp_u, " y[%3d]%12.3E%12.3E%8.2f  %s\n",
							 i, y_max[i], y_min[i], y_width[i], y_name[i]);
					}

					fclose(fp_u);	// վեΥ
					fclose(fp_d);	// եǡեΥ
					fclose(fp_t);	// ƥݥեΥ
					break;

				} else if (strncmp(sline, "$$ Failure", 10) == 0) {	// ׻Ԥξ
					fclose(fp_t);   // ƥݥեΥ
					break;
					
				} else if (strlen(sline)>3) {	//	ǡԤξ
					fprintf(fp_t, "%s", sline);	// ƥݥե˽񤭹
					cnt_d++;					// ǡԿ򥫥ȥå
				} // ǡԼ end-if
			} // ǡɤ߹ end-while
		} // ǡ end-if
	} // ϥեɹ end-while
	
	if (cnt_f) {
		log_sys("### Finish successfully.\n");
	} else {
		log_sys("### ERROR!! There is no datum for graph.\n");
		goto err;
	}
					
	fclose(fp_i);
	fclose(fp_s);

	return 0;

err:;
	return -1;
}

//--------------------- getSurveyStr ------------------------------------
//	̥եΥѥ᡼٥ιԤ˹Ԥä˸ƤФ졢
//	aline ˡNo.  ʹߤ֤
//
static void getSurveyStr(char *tline, char *aline)
{
    register char *cpt;
    register char *cpa;
    int f_start=0;

    cpt = tline;	// ɤԤΥݥ
    cpa = aline;	// ̤Ȥ֤ԤΥݥ

    for (; *cpt; ) {	// ϤΥ롼
		if (*cpt == '\n' || *cpt == '\0') {	// Ԥνλ
			break;
		}
	   	if (*cpt == 'N') f_start = 1;
		if (f_start) {	// No.  N ʹߤ񤭹
	   		*(cpa++) = *(cpt++);
		} else {		// ɤФ
			cpt++;
		}
    }

	*cpa   = '\0';
}

//--------------------- getData ------------------------------------
//	ǡԤλ˸ƤФ졢ǡvar[]᤹
//	꥿ͤϥǡο
//
static int getData(double var[], char *tline)
{
	int  i=0, cnt_d=0;
	char cdata[MAX_VAR_NUM][20];
	char *cp, delim=',';

	cp = tline;
	for (;;) {	// βϥ롼
		if (*cp=='\n' || *cp=='\0' || *cp=='\r') {	// Ԥν
			if (i>0) {	// cdataκǸǤǤкǸNULL­
				cdata[cnt_d][i] = '\0';
				cnt_d++;
			}
			*cp++ = '\n';	// tline 
			*cp = '\0';
			break;	// 롼פȴƽλ
		} else if (*cp==delim) {	// ǥߥãcdataμǤ˰ܹ
			cdata[cnt_d][i] = '\0';
			i=0;
			cp++;
			cnt_d++;
		} else {	// ʳʸǤХǡȤƽ񤭹
			cdata[cnt_d][i++] = *cp++;
		}
	}

	for ( i=0; i<cnt_d; i++) var[i] = atof(cdata[i]);

	return cnt_d;	// ǡԤξϤǿ֤
}
