/***********************************************************************
 *
 *     ̿ߥ졼
 *
 *         ѥ᡼
 *
 ***********************************************************************/

#ifndef _PARAMETER_T_
#define _PARAMETER_T_

#define PARAM_TYPE_NONE		0
#define PARAM_TYPE_KA		1
#define PARAM_TYPE_KD		2
#define PARAM_TYPE_KX		3
#define PARAM_TYPE_KB		4
#define PARAM_TYPE_KP		5
#define PARAM_TYPE_KPD		6
#define PARAM_TYPE_KM		7
#define PARAM_TYPE_KMD		8
#define PARAM_TYPE_KTR		9
#define PARAM_TYPE_KXG		10
#define PARAM_TYPE_F		11
#define PARAM_TYPE_Q		12
#define PARAM_TYPE_KMICH	13
#define PARAM_TYPE_MAXPARAM	14

/* ѥ᡼̡ʸ */
static char *paramTypeStr[] = {
	"NONE",
	"ka",
	"kd",
	"kx",
	"Kb",
	"kp",
	"kpd",
	"km",
	"kmd",
	"ktr",
	"kxg",
	"f",
	"Q",
	"Kmich",
};

/* ѥ᡼٥ */
static char *paramLabel[] = {
	"NONE",
	"binding_association_rate_constant",
	"dissociation_rate_constant",
	"reaction_rate_constant",
	"binding_constant",
	"translation_rate_constant",
	"decomposition_rate_constant",
	"transcription_rate_constant",
	"decomposition_rate_constant",
	"transport_rate_constant",
	"reaction_rate_constant",
	"power_coefficient",
	"reaction_rate_constant",
	"Michaelis_constant",
};

typedef struct _parameter_t {
	struct _parameter_t	*next;		/*  */
	char			*name;		/* ̾ */
	int			index;		/* ǥå */
	int			type;		/*  */
	int			reactantID;	/* Υѥ᡼ؤ뼫ʬʬ򤵤ʪ specieID (kmd/kpd ) */
} Parameter_t;

#endif /* _PARAMETER_T_ */
