/***********************************************************************
 *
 *     ̿ߥ졼
 *
 *         ʪ (̤ȤƤɽӥꥹȲΤ wrapper)
 *
 ***********************************************************************/

#ifndef _PLAYER_T_
#define _PLAYER_T_

#include "TotalEnzymeEq.h"
#include "CSpecie.h"

/* ѿμ */
#define VARIABLE_TYPE_CONST		1	/*  */
#define VARIABLE_TYPE_ALGE_COMPLEX	2	/* ѿ */
#define VARIABLE_TYPE_ALGE_MONOMER	3	/* ѿ */
#define VARIABLE_TYPE_DIFF_CMA		4	/* ʬѿ */
#define VARIABLE_TYPE_DIFF_GMA		5	/* ʬѿ */
#define VARIABLE_TYPE_UNKNOWN		6	/* ̤ */

/* ʪμ */
#define PLAYER_TYPE_NONE		0	/* ʤ */
#define PLAYER_TYPE_REACTANT		1	/* ȿʪ */
#define PLAYER_TYPE_PRODUCT		2	/* ȿʪ */
#define PLAYER_TYPE_MODIFIER		3	/* ȿʪ */
#define PLAYER_TYPE_MODIFIER_COMPLEX	4	/* ȿʪȿʪʣ */
#define PLAYER_TYPE_TARGET		11	/* å (Parameter  f  Kmich ξȤ) */

typedef struct _player_t {
	struct _player_t	*next;		/*  */
	int			variableType;	/* ѿ */
	int			constantIndex;	/* ʪȤưΥǥåֹ */
	double			stoichiometry;	/* specieReference ꥹȲȤ˻Ѥ */

	/* Specie ͳξ */
	int			specieID;
	char			name[NAME_LENGTH];
	int			compartment;
	char			compartment_suffix[SUFFIX_LENGTH];

	/* SpecieAttribute ͳξ */
	int			specieClass;
	int			massBalance;
	int			totalAmount;
	int			decomposition;
	int			initialAmount_isValid;
	double			initialAmount;

	/* ListOfElements ͳξ */
	int			numberOfElements;
	CSpecieReference_t	*specieReference;

	/* GMA / MM ѤΥե饰ѿ */
	int			isRP_GMA;	/* GMA / MM  Reactant ޤ Product ȤƴͿ뤳Ȥ 1 ˤե饰 */
	int			isTotal;	/* GMA / MM  Modifier ȤƴͿ isTotal  PARSEDAE_TRUE Ǥ뤳Ȥ PARSEDAE_TRUE ˤե饰 */
	TotalEnzymeEq_t		*totalEnzymeEq;	/* ʪФ̼Ȥ˻Ѥ */
} Player_t;

#endif /* _PLAYER_T_ */
