/***********************************************************************
 *
 *     ̿ߥ졼
 *
 *         
 *
 ***********************************************************************/

#ifndef _TEMPINFO_T_
#define _TEMPINFO_T_

#include "Player.h"
#include "Equation.h"
#include "Parameter.h"

typedef struct {
	int			convType_GeneProtein;	/* Gene-Protein ؤѴ */
	int			convType_Metabolic;	/* Metabolic ؤѴ */
	int			numberOfConstants;	/* ο */

	/* ʪ () */
	int			numberOfSpecies;	/* ʪο */
	Player_t		*variables;		/* ʪ */
	Equation_t		*equations;		/*  */
	Player_t		*variables_total;	/* ̾ */
	Equation_t		*equations_total;	/* ̾ */

	/* ѥ᡼ (¤) */
	Parameters_t		parameters;		/* ѥ᡼ */

	/* ɽ (¤) */
	TemporaryEqs_t		temporaryEqs;		/* ɽ */

	/* ʪ () */
	CListOfSpecies_t	*listOfSpecies;		/* ʪΥꥹ */

	/* ʪ¸߾ () */
	CListOfCompartments_t	*listOfCompartments;	/* ¸߾Υꥹ */

} TempInfo_t;

#endif /* _TEMPINFO_T_ */
