/***********************************************************************
 *
 *     ̿ߥ졼
 *
 *         parsedae إåե
 *
 ***********************************************************************/

/* ɸ C 饤֥ */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>

/* ̿ߥ졼 ƥ饤֥ */
#include "logUtil.h"

/* Java JNI 饤֥ */
#include <jni.h>

/* jutil 饤֥ */
#include "c_dbg.h"
#include "ju_conv.h"

/* parsedae  */
#include "parsedae_const.h"

/* parsedae  Java <-> C ǡѴ¤ */
#include "JModelPack.h"

/* sanac  Model ¤ (C ) */
#include "CModel.h"

/* ѹ¤ */
#include "OutputInfo.h"

/*  */
#include "TempInfo.h"

/* 󥯥ꥹѹ¤ */
#include "Queue.h"

/* Ѵ */
static char *convTypeStr[] = {
	"NONE",
	"CMA",
	"TPP_STEADYSTATE_1",
	"TPP_STEADYSTATE_2",
	"TPP_RAPID",
	"GMA",
	"MM"
};

/* reactionType */
static char *reactionTypeStr[] = {
	"none",
	"binding",
	"binding_with_stoichiometric_changes",
	"homo_association_or_modification",
	"homo_association_or_modification_with_stoichiometric_changes",
	"elimination",
	"elimination_with_stoichiometric_changes",
	"reversible_conversion",
	"irreversible_conversion",
	"reversible_conversion_regarding_multicomponent",
	"irreversible_conversion_regarding_multicomponent",
	"transport",
	"option_transport",
	"transcription",
	"translation",
	"degradation"
};

/* reactionType */
static char *specieClassStr[] = {
	"none",
	"DNA_gene",
	"DNA_promoter",
	"DNA_enhancer",
	"DNA_others",
	"RNA",
	"protein",
	"metabolite",
	"environmental_factor",
	"ion_signal",
	"complex / modifier_complex",
	"modified",
	"small_molecule",
	"text_option",
	"others"
};

/* reactionType ˤ reaction ʬ */
static int reactionClassWithModifier[] = {
	REACTION_CLASS_NONE,	/* ̤ */
	REACTION_CLASS_NONE,	/* BINDING */
	REACTION_CLASS_3,	/* BINDING_WITH_STOICHIOMETRIC_CHANGES */
	REACTION_CLASS_NONE,	/* HOMO_ASSOCIATION_OR_MODIFICATION */
	REACTION_CLASS_3,	/* HOMO_ASSOCIATION_OR_MODIFICATION_WITH_STOICHIOMETRIC_CHANGES */
	REACTION_CLASS_NONE,	/* ELIMINATION */
	REACTION_CLASS_3,	/* ELIMINATION_WITH_STOICHIOMETRIC_CHANGES */
	REACTION_CLASS_NONE,	/* REVERSIBLE_CONVERSION */
	REACTION_CLASS_3,	/* IRREVERSIBLE_CONVERSION */
	REACTION_CLASS_NONE,	/* REVERSIBLE_CONVERSION_REGARDING_MULTICOMPONENT */
	REACTION_CLASS_3,	/* IRREVERSIBLE_CONVERSION_REGARDING_MULTICOMPONENT */
	REACTION_CLASS_3,	/* TRANSPORT */
	REACTION_CLASS_3,	/* OPTION_TRANSPORT */
	REACTION_CLASS_gene1,	/* TRANSCRIPTION */
	REACTION_CLASS_NONE,	/* TRANSLATION */
	REACTION_CLASS_3	/* DEGRADATION */
};
static int reactionClassWithoutModifier[] = {
	REACTION_CLASS_NONE,	/* ̤ */
	REACTION_CLASS_2,	/* BINDING */
	REACTION_CLASS_1,	/* BINDING_WITH_STOICHIOMETRIC_CHANGES */
	REACTION_CLASS_2,	/* HOMO_ASSOCIATION_OR_MODIFICATION */
	REACTION_CLASS_1,	/* HOMO_ASSOCIATION_OR_MODIFICATION_WITH_STOICHIOMETRIC_CHANGES */
	REACTION_CLASS_2,	/* ELIMINATION */
	REACTION_CLASS_1,	/* ELIMINATION_WITH_STOICHIOMETRIC_CHANGES */
	REACTION_CLASS_2,	/* REVERSIBLE_CONVERSION */
	REACTION_CLASS_1,	/* IRREVERSIBLE_CONVERSION */
	REACTION_CLASS_2,	/* REVERSIBLE_CONVERSION_REGARDING_MULTICOMPONENT */
	REACTION_CLASS_1,	/* IRREVERSIBLE_CONVERSION_REGARDING_MULTICOMPONENT */
	REACTION_CLASS_1,	/* TRANSPORT */
	REACTION_CLASS_1,	/* OPTION_TRANSPORT */
	REACTION_CLASS_1,	/* TRANSCRIPTION */
	REACTION_CLASS_1,	/* TRANSLATION */
	REACTION_CLASS_1	/* DEGRADATION */
};

/* reactionType ˤѥѥ᡼η */
/* REACTION_CLASS_1 ޤ REACTION_TYPE_2 ξΤͭ */
static int paramTypeOfReactionType[] = {
	PARAM_TYPE_NONE,	/* ̤ */
	PARAM_TYPE_KA,		/* 2:BINDING */
	PARAM_TYPE_KX,		/* 1:BINDING_WITH_STOICHIOMETRIC_CHANGES */
	PARAM_TYPE_KA,		/* 2:HOMO_ASSOCIATION_OR_MODIFICATION */
	PARAM_TYPE_KX,		/* 1:HOMO_ASSOCIATION_OR_MODIFICATION_WITH_STOICHIOMETRIC_CHANGES */
	PARAM_TYPE_KA,		/* 2:ELIMINATION */
	PARAM_TYPE_KX,		/* 1:ELIMINATION_WITH_STOICHIOMETRIC_CHANGES */
	PARAM_TYPE_KX,		/* 2:REVERSIBLE_CONVERSION */
	PARAM_TYPE_KX,		/* 1:IRREVERSIBLE_CONVERSION */
	PARAM_TYPE_KX,		/* 2:REVERSIBLE_CONVERSION_REGARDING_MULTICOMPONENT */
	PARAM_TYPE_KX,		/* 1:IRREVERSIBLE_CONVERSION_REGARDING_MULTICOMPONENT */
	PARAM_TYPE_KTR,		/* 1:TRANSPORT */
	PARAM_TYPE_KTR,		/* 1:OPTION_TRANSPORT */
	PARAM_TYPE_KM,		/* 1:TRANSCRIPTION */
	PARAM_TYPE_KP,		/* 1:TRANSLATION */
	PARAM_TYPE_KX		/* 1:DEGRADATION */
};

/* convType  CMA  GMA ̤ */
static int convType_rough[] = {
	CONVTYPE_NONE,		/* CONVTYPE_NONE */
	CONVTYPE_CMA,		/* CONVTYPE_CMA */
	CONVTYPE_CMA,		/* CONVTYPE_TPP_SS1 */
	CONVTYPE_CMA,		/* CONVTYPE_TPP_SS2 */
	CONVTYPE_CMA,		/* CONVTYPE_TPP_RAPID */
	CONVTYPE_GMA,		/* CONVTYPE_GMA */
	CONVTYPE_GMA,		/* CONVTYPE_MM */
	CONVTYPE_NONE,		/* CONVTYPE_GENE0 */
	CONVTYPE_NONE,		/* CONVTYPE_GENE1 */
	CONVTYPE_NONE		/* CONVTYPE_TRANSLATION */
};

/* reactionType  GMA / MM ѴǽɤȽꤹ */
/* PARSEDAE_OK ʤѴǽPARSEDAE_NG ʤԲǽ */
static int checkReactionType_GMA[] = {
	PARSEDAE_NG,	/* ̤ */
	PARSEDAE_NG,	/* BINDING */
	PARSEDAE_OK,	/* BINDING_WITH_STOICHIOMETRIC_CHANGES */
	PARSEDAE_NG,	/* HOMO_ASSOCIATION_OR_MODIFICATION */
	PARSEDAE_OK,	/* HOMO_ASSOCIATION_OR_MODIFICATION_WITH_STOICHIOMETRIC_CHANGES */
	PARSEDAE_NG,	/* ELIMINATION */
	PARSEDAE_OK,	/* ELIMINATION_WITH_STOICHIOMETRIC_CHANGES */
	PARSEDAE_OK,	/* REVERSIBLE_CONVERSION */
	PARSEDAE_OK,	/* IRREVERSIBLE_CONVERSION */
	PARSEDAE_OK,	/* REVERSIBLE_CONVERSION_REGARDING_MULTICOMPONENT */
	PARSEDAE_OK,	/* IRREVERSIBLE_CONVERSION_REGARDING_MULTICOMPONENT */
	PARSEDAE_OK,	/* TRANSPORT */
	PARSEDAE_OK,	/* OPTION_TRANSPORT */
	PARSEDAE_NG,	/* TRANSCRIPTION */
	PARSEDAE_NG,	/* TRANSLATION */
	PARSEDAE_OK	/* DEGRADATION */
};

/* specieClass  GMA / MM ѴǽɤȽꤹ */
/* PARSEDAE_OK ʤѴǽPARSEDAE_NG ʤԲǽ */
static int checkSpecieClass_GMA[] = {
	PARSEDAE_NG,	/* ̤ */
	PARSEDAE_NG,	/* DNA_GENE */
	PARSEDAE_NG,	/* DNA_PROMOTER */
	PARSEDAE_NG,	/* DNA_ENHANCER */
	PARSEDAE_NG,	/* DNA_OTHERS */
	PARSEDAE_NG,	/* RNA */
	PARSEDAE_NG,	/* PROTEIN */
	PARSEDAE_OK,	/* METABOLITE */
	PARSEDAE_OK,	/* ENVIRONMENTAL_FACTOR */
	PARSEDAE_OK,	/* ION_SIGNAL */
	PARSEDAE_NG,	/* COMPLEX (MODIFIERCOMPLEX) */
	PARSEDAE_OK,	/* MODIFIED */
	PARSEDAE_OK,	/* SMALL_MOLECULE */
	PARSEDAE_OK,	/* TEXT_OPTION */
	PARSEDAE_OK	/* OTHERS */
};

/* GMA / MM Ǥ convType ˤ뼰Фѥѥ᡼η */
static int paramTypeOfConvType_GMA_eq[] = {
	0, 0, 0, 0, 0,		/* NONE/CMA/TPP_SS1/TPP_SS2/RAPID ̵ط */
	PARAM_TYPE_KXG,		/* GMA */
	PARAM_TYPE_Q		/* Michaelis-Menten */
};

/* GMA / MM Ǥ convType ˤʪФѥѥ᡼η */
static int paramTypeOfConvType_GMA_player[] = {
	0, 0, 0, 0, 0,		/* NONE/CMA/TPP_SS1/TPP_SS2/RAPID ̵ط */
	PARAM_TYPE_F,		/* GMA */
	PARAM_TYPE_KMICH	/* Michaelis-Menten */
};

/* parsedaeUtil.cpp */
extern Player_t* PlayerDup (Player_t *src);
extern Queue_t* Enqueue (Queue_t **root, Queue_t *newMember);
extern int SearchPlayerBySpecieID (Player_t *players, int players_n, int specieID);
extern void AddTermToEquation (Equation_t *equation, Term_t *term);
extern void AddVariateToTerm (Term_t *term, Player_t *player, double stoichiometry);
extern Term_t* MakeNewTerm (double stoichiometry, Parameter_t *parameter);
extern int WritePlayer (char **ret, Player_t *player, char *prefix);
extern void ReadMemberOfReaction (CReaction_t *reaction, CListOfPlayers_t **listOfReactants, int *numberOfReactants, CListOfPlayers_t **listOfProducts, int *numberOfProducts, CListOfPlayers_t **listOfModifiers, int *numberOfModifiers, CListOfPlayers_t **modifierComplex, int *numberOfModifierComplex, int *reactionType);
extern Parameter_t* MakeParam (TempInfo_t *tempInfo, int paramType, CListOfPlayers_t *listOfModifiers, CListOfPlayers_t *listOfReactants, Player_t *target, Player_t *reactant);
extern void NumberConstantPlayer (TempInfo_t *tempInfo, Player_t *v);
extern void NumberConstantPlayers (TempInfo_t *tempInfo);

#ifdef DEBUG
extern void Debug_printListOfReactions (CListOfReactions_t *listOfReactions);
#endif

/* inputXML.cpp */
extern int ParseXML(char *filename, CModel_t *model, OutputInfo_t *outputinfo, int filetype);

/* tppmake.cpp */
extern int SetTPP (TempInfo_t *tempInfo);

/* gma.cpp */
extern void AddFluxToEquation (Equation_t *eq, FluxEq_t *fluxEq, double stoichiometry);
extern void MakeFluxEq_decomp (TempInfo_t *tempInfo, Player_t *v, int convType);
extern int ReadReactions_GMA (TempInfo_t *tempInfo, CModel_t *model);

/* makeOutputInfo.cpp */
extern int MakeOutputInfo (CModel_t *model, OutputInfo_t *outputInfo, int filetype);

/* makeOutputFile.cpp */
extern void MakeOutputFile (FILE *fp, OutputInfo_t *outputInfo, int filetype, int outputType);

/* convertphp.cpp */
extern void ConvertPHP (FILE *fp, OutputInfo_t *outputInfo, CModel_t *model);

extern JNIEnv		*env;
