<?php
//	(drawGraph.php)

	include("setSession.inc");
	require("rwFile.php");

	$headtitle="G".$graphNo;
	$cssfile = "drawGraph.css";

	$postUrl = $PHPSELF;

	// ܥ󥿥ȥ
	include("buttonTitle.inc");

	if (!$legend && !$no_legend && !$detail) {	// ǽ˳

		include("graphDetails.inc");

		// դΥȥΥǡarray˵ͤߥåǡȤƳǼ

		$graphDetails = array("plotType"=>$plotType,
			"dotType"=>$dotType, "dotSize"=>$dotSize, "lineWidth"=>$lineWidth,
			"XSIZE"=>$XSIZE, "YSIZE"=>$YSIZE,
			"f_grid"=>$f_grid, "f_legend"=>$f_legend,
			"Xlegend"=>$Xlegend, "Ylegend"=>$Ylegend,
			"backColor"=>$backColor, "textColor"=>$textColor,
			"XgridColor"=>$XgridColor, "YgridColor"=>$YgridColor,
			"tickColor"=>$tickColor, "titleColor"=>$titleColor,
			"labelColor"=>$labelColor);

		$graphCTRL =array("title"=>$title,
			"label"=>array($label1,$label2,$label3,$label4,$label5),
			"scale"=>array($scale1,$scale2,$scale3,$scale4,$scale5),
			"color"=>array($color1,$color2,$color3,$color4,$color5),
			"flag"=>array($f_notDraw1,$f_notDraw2,$f_notDraw3,$f_notDraw4,$f_notDraw5),
			"Afactor"=>array($x_factor,$y_factor),
			"Amax"=>array($x_max,$y_max),
			"Amin"=>array($x_min,$y_min),
			"Astep"=>array($x_step,$y_step),
			"Alabel"=>array($x_label,$y_label),
			"Aunit"=>array($x_unit,$y_unit),
			"Aunitf"=>array($x_unitf,$y_unitf));

		session_register("graphDetails");
		session_register("graphCTRL");

		// ߤΥֹ񤭽Ф
		chdir($sessionDir);
		if (($fp = fopen ("graphNo.txt", "w"))) {
			fwrite($fp, $graphNo."\n");
			fclose ($fp);
				} else {
			die ("Cannot open ".$file.".");
		}
	} else {	// ܺԤäξ
		if ($legend) $graphDetails[f_legend] = 1;
		if ($no_legend) $graphDetails[f_legend] = 0;
		if ($detail) {
			$backColor = array($Rbg, $Gbg, $Bbg);
			$textColor = array($Rnt, $Gnt, $Bnt);
			$XgridColor = array($Rxg, $Gxg, $Bxg);
			$YgridColor = array($Ryg, $Gyg, $Byg);
			$tickColor = array($Rtick, $Gtick, $Btick);
			$titleColor = array($Rtitle, $Gtitle, $Btitle);
			$labelColor = array($Rlbl, $Glbl, $Blbl);

			$graphDetails = array("plotType"=>$plotType,
				"dotType"=>$dotType, "dotSize"=>$dotSize, "lineWidth"=>$lineWidth,
				"XSIZE"=>$XSIZE, "YSIZE"=>$YSIZE,
				"f_grid"=>$f_grid, "f_legend"=>$f_legend,
				"Xlegend"=>$Xlegend, "Ylegend"=>$Ylegend,
				"backColor"=>$backColor, "textColor"=>$textColor,
				"XgridColor"=>$XgridColor, "YgridColor"=>$YgridColor,
				"tickColor"=>$tickColor, "titleColor"=>$titleColor,
				"labelColor"=>$labelColor);
		}
	}

	// ܺѤ˥ǡ
	if ($legend || $no_legend) {
		$plotType = $graphDetails[plotType];
		$dotType = $graphDetails[dotType];
		$dotSize = $graphDetails[dotSize];
		$lineWidth = $graphDetails[lineWidth];
		$XSIZE = $graphDetails[XSIZE];
		$YSIZE = $graphDetails[YSIZE];
		$f_grid = $graphDetails[f_grid];
		$f_legend = $graphDetails[f_legend];
		$Xlegend = $graphDetails[Xlegend];
		$Ylegend = $graphDetails[Ylegend];
	}
	list($Rbg, $Gbg, $Bbg) = $graphDetails[backColor];
	list($Rnt, $Gnt, $Bnt) = $graphDetails[textColor];
	list($Rxg, $Gxg, $Bxg) = $graphDetails[XgridColor];
	list($Ryg, $Gyg, $Byg) = $graphDetails[YgridColor];
	list($Rtick, $Gtick, $Btick) = $graphDetails[tickColor];
	list($Rtitle, $Gtitle, $Btitle) = $graphDetails[titleColor];
	list($Rlbl, $Glbl, $Blbl) = $graphDetails[labelColor];

?>

<html>
	<head>
		<title><?php print $headtitle ?></title>
		<link rel="stylesheet" type="text/css" href="css/<?php print $cssfile ?>" />
	</head>
	<body id="body">
		<div id="title">
			<?php print $titleValue; ?>
			<hr />
		</div>
		<div id="ctrl">
			<form action="<?php print $postURL; ?>">
				<input type="button" onClick="window.print()" value="print" title="<?php
					print $bt_print ?>"/>
       			<input type="button" value="close" onClick="window.close()" title="<?php
					print $bt_close ?>"/>
<?php
if ($graphDetails[f_legend]) {
?>
				<input name="no_legend" type="submit" value="no legend" title="<?php
					print $bt_legend ?>"/>
				<input name="graphNo" type="hidden" value="<?php print $graphNo; ?>"/>
<?php
} else {
?>
				<input name="legend" type="submit" value="legend" title="<?php
					print $bt_legend ?>"/>
				<input name="graphNo" type="hidden" value="<?php print $graphNo; ?>"/>
<?php
}
?>
       			<input type="button" value="set details" title="<?php print $bt_detail ?>"
						 onClick="location.href='setGdetails.php?graphNo=<?php print $graphNo; 
							?>&plotType=<?php print $plotType;
							?>&dotType=<?php print $dotType;
							?>&dotSize=<?php print $dotSize;
							?>&lineWidth=<?php print $lineWidth;
							?>&XSIZE=<?php print $XSIZE;
							?>&YSIZE=<?php print $YSIZE;
							?>&f_grid=<?php print $f_grid;
							?>&f_legend=<?php print $f_legend;
							?>&Xlegend=<?php print $Xlegend;
							?>&Ylegend=<?php print $Ylegend;
							?>&Rbg=<?php print $Rbg;
							?>&Gbg=<?php print $Gbg;
							?>&Bbg=<?php print $Bbg;
							?>&Rnt=<?php print $Rnt;
							?>&Gnt=<?php print $Gnt;
							?>&Bnt=<?php print $Bnt;
							?>&Rxg=<?php print $Rxg;
							?>&Gxg=<?php print $Gxg;
							?>&Bxg=<?php print $Bxg;
							?>&Ryg=<?php print $Ryg;
							?>&Gyg=<?php print $Gyg;
							?>&Byg=<?php print $Byg;
							?>&Rtick=<?php print $Rtick;
							?>&Gtick=<?php print $Gtick;
							?>&Btick=<?php print $Btick;
							?>&Rtitle=<?php print $Rtitle;
							?>&Gtitle=<?php print $Gtitle;
							?>&Btitle=<?php print $Btitle;
							?>&Rlbl=<?php print $Rlbl;
							?>&Glbl=<?php print $Glbl;
							?>&Blbl=<?php print $Blbl;
							?>', 'details', 'resizable=yes,menubar=no,location=no,scrollbars=yes'" />

				<hr />
			</form>
		</div>
		<div id="contents">
			<img src="createGraph.php?dummy=<?php print microtime(); ?>">
<?php
/*
print "detail =".$detail."<br />";
print "Xunit =".$Xunit."<br />";
print "Xlabel =".$Xlabel."<br />";
print "f_notDraw1 =".$f_notDraw1."<br />";
print "XSIZE =".$XSIZE."<br />";
print "Rbg =".$Rbg."<br />";
print_r($graphDetails);
print "<br />";
print_r($graphCTRL);
print "<br />";
*/
?>
		</div>
	</body>
</html>
