<?php
//	(setGraph.php)

	include("setSession.inc");
	require("rwFile.php");

	$headtitle="Set Graph Data";
	$bodytitle="Set Graph Data";
	$cssfile="setGraph.css";

	// ܥ󥿥ȥ
	include("buttonTitle.inc");

	chdir($sessionDir);

	// ѥǡեκ
	system($dirBin."makeGraphData -I".$resultTimeFile.$batch_log, $out);

	// ѥ᡼٥ѥꥹȤκ
	if (!$out) {	// makeGraphData ｪλ
		if (($fp = fopen ("graphSurvey.txt", "r"))) {
			$n_survey = 0;
			while (!feof ($fp)) {
				$buffer = fgets($fp, 4096);
				if (strlen($buffer)) $survey[++$n_survey] = $buffer;
			}
			fclose ($fp);
		} else {
			$out = 1;
			$str_err = "Error!! Cannot read graphSurvey.txt.";
		}
	} else {	// makeGraphData Ԥ
		$str_err = "Error!! Cannot make graph data file.";
	}

	// ǡʤy[1]˳Ƥ
	if (file_exists("eq.txt")) {
		if (($fp = fopen ("eq.txt", "r"))) {
			for ($i=1; $i<=5; $i++) {
				$data_ = "data_".$i;
				$label = "label".$i;
				$info = fscanf ($fp,"%s\t%s\n");
				list ($$data_, $$label) = $info;
			}
			fclose ($fp);
		} else {
			die ("Cannot open eq.txt");
		}
	} else {
		$data_1 = "y[1]";
		$data_2 = "y[2]";
		$data_3 = "y[3]";
		$data_4 = "y[4]";
		$data_5 = "y[5]";
		$label1 = "y1";
		$label2 = "y2";
		$label3 = "y3";
		$label4 = "y4";
		$label5 = "y5";
	}

	// graphNo.txt ɤ߹ǥդֹ򤽤1äΤȤ
	// graphNo.txt drawGraph.phpǥդºݤ˽˽񤭽Ф
	if (file_exists("graphNo.txt")) {
		$graphNo = readTextFile2("graphNo.txt") + 1;
	} else {
		$graphNo = 1;
	}

	// $surveyNo ꤵƤʤХǥեȤǽΤΤȤ
	if (!$surveyNo) $surveyNo = 1;

?>

<html>
	<head>
		<title><?php print $headtitle ?></title>
		<link rel="stylesheet" type="text/css" href="css/<?php print $cssfile ?>" />
	</head>
	<body id="body">
		<p id="bodytitle"><?php print $bodytitle ?></p>
		<p id="title"><?php print $titleValue; ?></p>
		<div id="ctrl">
			<form name="setSurvey" action="<?php print $PHPSELF; ?>">
<?php
if (!$out) {	// ˽λ
?>
				<input type="button" onClick="window.print()" value="print" title="<?php
					print $bt_print ?>"/>
<?php
}
?>
           		<input type="button" value="Close" onClick="window.close()" title="<?php
					print $bt_close ?>"/>
<?php
if ($n_survey) {	// ѥ᡼٥ξ
	print "Select Case &gt;&gt;<select name='surveyNo'>";
	for ($i=1; $i<=$n_survey; $i++) {
		print "<option value='".$i."'>".$survey[$i]."</option>";
	}
	print "</select>";
	print "<input type='submit' value='select' title='".$bt_pselect."'/>";
}
?>
			</form>

		</div>
		<hr id="line"/>
		<div id="memo">
<?php
if ($n_survey) {	// ѥ᡼٥ξ
	print "<pre><b style='font-size:12;color:blue'>Selected case : ". 
				$survey[$surveyNo]."</b></pre>";
}
?>
		</div>
		<hr id="line2"/>
		<div id="contents">
<?php
if (!$out) {	// ˽λ
	print "<pre>";
	readTextFile("graphInfo_".$surveyNo.".txt");
	print "</pre>";
} else {
	print "out = ".$out;
	print "<h1 style='color:red'>".$str_err."</h1>";
	readTextFile($logFile);
	die();
}
?>
		</div>
		<div id="ctrl2">
			<form name="setLine" method="POST" action="setGraph2.php">
				<input type="hidden" name="surveyNo"
							 value="<?php print $surveyNo; ?>"/>
				<input type="hidden" name="survey"
							value="<?php print $survey[$surveyNo]; ?>"/>
				<input type="hidden" name="n_survey"
							value="<?php print $n_survey; ?>"/>
				<table>
					<tr align="center">
						<td>No.</td><td>Label</td><td>Expression</td>
					</tr>
					<tr><td align="right">1</td>
						<td>
							<input type="text" name="label1" value="<?php
									print $label1; ?>" size="15"/>
						</td>
						<td>
							<input type="text" name="data_1" value="<?php
									print $data_1; ?>" size="30"/><br />
						</td>
					</tr>
					<tr><td align="right">2</td>
						<td>
							<input type="text" name="label2" value="<?php
									print $label2; ?>" size="15"/>
						</td>
						<td>
							<input type="text" name="data_2" value="<?php
									print $data_2; ?>" size="30"/><br />
						</td>
					</tr>
					<tr><td align="right">3</td>
						<td>
							<input type="text" name="label3" value="<?php
									print $label3; ?>" size="15"/>
						</td>
						<td>
							<input type="text" name="data_3" value="<?php
									print $data_3; ?>" size="30"/><br />
						</td>
					</tr>
					<tr><td align="right">4</td>
						<td>
							<input type="text" name="label4" value="<?php
									print $label4; ?>" size="15"/>
						</td>
						<td>
							<input type="text" name="data_4" value="<?php
									print $data_4; ?>" size="30"/><br />
						</td>
					</tr>
					<tr><td align="right">5</td>
						<td>
							<input type="text" name="label5" value="<?php
									print $label5; ?>" size="15"/>
						</td>
						<td>
							<input type="text" name="data_5" value="<?php
									print $data_5; ?>" size="30"/><br />
						</td>
					</tr>
					<tr><td><br /></td></tr>
					<tr><td></td><td></td>
						<td align="right">
							<input type='submit' value='submit' title="<?php
									print $bt_submit ?>"/>
						</td>
					</tr>
				</table>
				<input type="hidden" name="graphNo"
							value="<?php print $graphNo; ?>"/>
			</form>
		</div>
	</body>
</html>
