<?php
//	ɽ

	include("setSession.inc");
	require("rwFile.php");

	$headtitle="Results";
	$bodytitle="Results";
	$cssfile="showResult.css";
	$preUrl = "setParam.php";
	$postUrl = $PHPSELF."?from=own";

	// ܥ󥿥ȥ
	include("buttonTitle.inc");

	chdir($sessionDir);

	if ($dynamic) {
		$resultFile	= $resultTimeFile;
		$view = "Dynamic";
		$std = 0;
		$sens = 0;
	} else if ($std) {
		$resultFile	= $resultSTDFile;
		$view = "Steady State";
		$dynamic = 0;
		$sens = 0;
	} else if ($sens) {
		$resultFile	= $resultSensFile;
		$view = "Sensitivity";
		$dynamic = 0;
		$std = 0;
	}

	if ($from == "param") {	// setParam2 褿
		// 桼ؿȥѥ᡼ե
		if ($f_useSsys) {
			$myParam = $SparamFile;
			$myFunc = $SfuncFile;
		} else {
			$myParam = $paramFile;
			$myFunc = $usrfuncFile;
		}

		if ($f_parallelValue) {
			// ׻ξϥ٥ƥ٥CPUξʤProcˤ롣
			$num_survey = exec($dirBin."getSurveyNum.sh ".$myParam);
			$mpi = $mpirun.min($num_cpu, $num_survey);
//print "<br />mpi=".$mpi;
		} else {
			$mpi = $mpirun." 1";
		}
		if ($solverNo < 10) {
			$resultFile	= $resultTimeFile;
			$view = "Dynamic";
			$mySolver	= $mpi." simulator_".$my_id;
			$dynamic = 1;
		} else {
			$resultFile	= $resultSTDFile;
			$view = "Steady State";
			$mySolver	= $mpi." simulator_".$my_id;
			$std = 1;
		}

		// MathUserFunc.txt  usrfunc.cpp ˥ԡ
		exec("/bin/cp -f ".$myFunc." ".$usrcppFile);
		// MathCtrl.txt  MathParam.txt Ĥʤ input.txt ˤ
		exec("/bin/cat ".$ctrlFile." ".$myParam." > ".$inputFile);
		// simulator 򥳥ѥ뤷ƺ
		system("/usr/bin/make -f ../../Tools/etc/php.mk".$batch_log, $out);
		if ($out != 0) {	// ѥ뤬Ԥ
			$log = readTextFile2($logFile);
			postError("in compiling a simulator.", $log, $preUrl);
		}
		exec("/bin/mv simulator simulator_".$my_id);
		// ߥ졼μ¹
		if (file_exists($resultFile)) {
			unlink($resultFile);
		}
		//exec("/bin/sh ./kill.sh &");
		system($mySolver." -I".$inputFile." -O".$resultFile.$batch_log, $out);
		if ($out != 0) {	// ߥ졼顼λ
			$usage = "Failed !!";
		} else {			// ߥ졼ｪλ 
			$usage = "Succeeded !!";

			// ơե񤭴
			$status = "RESULT";
			writeStatus($statusFile, $my_path, $status, $convTypeValue_P, $convTypeValue_M);

			// Ϥǥѥ᡼٥Ǥʤϡ
			// ³S-systemΥѥ᡼ե롣
			//  simulator ΤΤ³롣顼äƤⲿ⤷ʤ
			if ($solverNo == 11 && $f_surveyValue == 0 && file_exists($GHFile)) {
				// make_s_param 򥳥ѥ뤷ƺ
				exec("/bin/cp -f ".$GHFile." ".$usrcppFile);
				system("/usr/bin/make -f ../../Tools/etc/php_s.mk >> "
														.$logFile." 2>&1", $out2);
				if ($out == 0) {	// ѥ뤬¹
					system("./make_s_param -I".$inputFile." -R"
					.$resultSTDFile." -S".$SparamFile." >> ".$logFile." 2>&1", $out2);
				}
			}
		}
	}

	if ($from == "select" || $sinit) {	// selectJob or sinit ξ
		// ˥ȥǡ¸ߤФɤ߹
		if (file_exists($ctrlFile)) {
			if (($fp = fopen ($ctrlFile,"r"))) {
				while($info = fscanf($fp,"%s\t;\t%s\n")) {
					list ($my_name, $value) = $info;
					if ($my_name == "SOLVER") {
						$solverNo = $value;
					}
				}
				fclose($fp);
			} else {
				$log = "";
				postError("Cannot read CTRL file.", $log, $preUrl);
			}
		}
		if ($solverNo < 10) {
			$resultFile	= $resultTimeFile;
			$view = "Dynamic";
			$dynamic = 1;
		} else if ($solverNo < 20) {
			$resultFile	= $resultSTDFile;
			$view = "Steady State";
			$std = 1;
		} else if ($solverNo >= 20) {
			$resultFile	= $resultSensFile;
			$view = "Sensitivity";
			$sens = 1;
		}
	}
	if ($sinit) {	// "save for init" å줿
		exec("/bin/mv -f ".$preInitFile." ".$initFile);
	}
?>

<html>
	<head>
		<title><?php print $headtitle ?></title>
		<link rel="stylesheet" type="text/css" href="css/<?php print $cssfile ?>" />
	</head>
	<body id="body">
		<p id="bodytitle">
<?php
print $bodytitle;
if ($f_useSsys == true && $from == "param") {
	print '<font style="color:red"> (S-System)</font>';
}
?>
		</p>
		<div id="usage"><?php print $usage ?></div>
		<p id="title"><?php print $titleValue; ?></p>
		<form action="<?php print $postUrl ?>" method="post">
			<div id="ctrl">
            	<input type="button" onClick="location='<?php
					print $preUrl ?>'" value="Back" title="<?php print $bt_back ?>"/>
				<input type="button" onClick="window.print()" value="print" title="<?php
					print $bt_print ?>">
            	<input type="button" onClick="location='selectAnalysis'"
					value="Select Ana." title="<?php print $bt_b_ana ?>"/>
				<input type="button" value="Registration" title="<?php print $bt_regi ?>"
			 	onClick="subWr=window.open('saveDB.php', 'saveDB',
			 	'resizable=yes,menubar=no,location=no,scrollbars=yes');subWr.focus()"/>
				<input type="button" value="Download" title="<?php print $bt_down ?>"
		  		onClick="subWd=window.open('download.php', 'download',
				'resizable=yes,menubar=no,location=no,scrollbars=yes');subWd.focus()"/>
<?php
if ($my_path != "direct") {
?>
				<input type="button" value="Chemical Eqs" title="<?php print $bt_disp_c ?>"
		  		onClick="subWdc=window.open('dispData.php?tg_item=<?php 
				print $disp_chemi ?>', 'disp_chemi',
				'resizable=yes,menubar=no,location=no,scrollbars=yes');subWdc.focus()"/>
<?php
}
?>
				<input type="button" value="Math Model" 
		  			onClick="subWdf=window.open('dispData.php?tg_item=<?php
					print $disp_model ?>', 'disp_model',
					'resizable=yes,menubar=no,location=no,scrollbars=yes');subWdf.focus()"
					title="<?php print $bt_disp_f ?>"/>
				<input type="button" value="User Funcs" title="<?php print $bt_disp_f ?>"
		  		onClick="subWdf=window.open('dispData.php?tg_item=<?php
				print $disp_func ?>', 'disp_eqs',
				'resizable=yes,menubar=no,location=no,scrollbars=yes');subWdf.focus()"/>
<?php
if (file_exists($preInitFile)) {
?>
				<input type="submit" value="save for input" name="sinit" title="<?php
					print $bt_save_i ?>"/>
<?php
}
if (file_exists($resultTimeFile) && $dynamic) {
?>
				<input type="button" value="Graph"  title="<?php print $bt_graph ?>"
		  		onClick="subWg = window.open('setGraph.php', 'set_graph',
				'resizable=yes, menubar=no,location=no,scrollbars=yes'); subWg.focus()"/>
<?php
}
?>
            	<input type="button" value="Quit"
					onClick="if(confirm('If you quit without saving data to the DB, you can restore data never again!!')) location.href='quitJob.php'" title="<?php print $bt_quit ?>"/>
				<br /><br /><b>View other results :</b>
<?php
if (file_exists($resultTimeFile) && $dynamic == "") {
?>
				<input type="submit" value="Dynamic" name="dynamic" title="<?php
					print $bt_Vtime ?>"/>
<?php
}
?>
<?php
if (file_exists($resultSTDFile) && $std == "") {
?>
				<input type="submit" value="Steady State" name="std" title="<?php
					print $bt_Vstd ?>"/>
<?php
}
?>
<?php
if (file_exists($resultSensFile) && $sens == "") {
?>
				<input type="submit" value="Sensitivity" name="sens" title="<?php
					print $bt_Vsens ?>"/>
<?php
}
?>
			</div>
			<hr id="line" />
			<div id="contents">
<?php
/*
print "<br />solverNo = ".$solverNo;
print "<br />dynamic = ".$dynamic;
print "<br />std = ".$std;
print "<br />sens = ".$sens;
print "<br />sinit = ".$sinit;
print "<br />out = ".$out;
*/
if (file_exists($resultFile) && $out == 0) {	// ɽorСｪλ
?>
				<p style="color:blue">========= Results(<b><?php print $view; ?></b>) =========</p>
				<pre><?php readTextFile($resultFile); ?></pre>
<?php
}
if ($from == "param") {	// ɽΤϷ׻
?>
				<p style="color:blue">========= Log =========</p>
				<pre><?php readTextFile($logFile); ?></pre>
<?php
}
if ($out != 0) {	// С۾ｪλξϤη̤ɽ
	if (file_exists("tmpResult.txt")) {
		$tmpFile = "tmpResult.txt";
		$tmpText = "Results";
	} else if (file_exists("tmpResult.txt_0")) {
		$tmpFile = "tmpResult.txt_0";
		$tmpText = "Results";
	} else {
		$tmpFile = $inputFile;
		$tmpText = "InputFile";
	}
?>
				<p style="color:red">========= <?php print $tmpText; ?>(<b>Failed!!</b>) =========</p>
				<pre><?php readTextFile($tmpFile); ?></pre>
<?php
}
?>
			</div>
		</form>
	</body>
</html>
