#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "utl_text.h"
#include "logUtil.h"

static char *head;	/* оʸ¸ */

/*-----
 * DelSpaceTabؿ
 * 	ʸ󤫤顤ȥ֤
 * 	ʸȤ
 * 	Ūˤϰǻꤵ줿Ƭ
 * 	ʸޤǤδ֤ζȥ֤
 *	̵͡
 *	ȥ֤ʸؤΥݥ(I/O)
 */
void DelSpaceTab(char *buf)
{
  	char 	temp_buf[512];	/* ¸ѥХåե */
  	int 	i,j = 0;	/* 롼ѿ */	

#ifdef DBG
	DBGW(10, ("DelSpaceTab enter.\n"));
#endif /* DBG */

	for (i = 0; buf[i] != '\0'; i++){
    		if (buf[i] == ' ' || buf[i] == '\t'){
      		} else {
      			temp_buf[j] = buf[i];
      			j++;
    		}
  	}
  	temp_buf[j] = '\0';

  	strcpy(buf, temp_buf);
#ifdef DBG
	DBGW(10, ("DelSpaceTab exit\n"));
#endif /* DBG */
}

	
/*-----
 * DelCommentؿ
 * 	ʸ󤫤顤Ȥ
 * 	ȤϡʸѴ
 * 	ʹߤϸʸζʸޤ
 * 	ƶʸ롥
 * 	)ݡȤΤϡιԤ#ʹߤ򥳥ȤȤ륿פΤ
 * 	̵͡
 * 	ȤʸؤΥݥ(I/0)
 */
void DelComment(char *buf)
{
	int	i;		/* 롼 */
	int	flag = 0;  	/* 0:1:ȸ */

#ifdef DBG
	DBGW(10, ("DelComment enter.\n"));
#endif /* DBG */
	
	for (i = 0; buf[i] != '\0'; i++){
		if(flag == 1) buf[i] = '\0';
		if((buf[i] == '#') && (flag == 0)){
			buf[i] = '\n';
			flag = 1;
		}
	}
#ifdef DBG
	DBGW(10, ("DelComment exit\n"));
#endif /* DBG */
}
		

/*-----
 * FindDelimؿ
 * 	ǥߥ򸫤Ĥindex֤
 *	ǥߥĤʤäʸκǸindex֤
 * 	͡ǥߥindex, FIND_NO_DELIM
 * 	ǥߥ򸡺ʸƬ(I)
 * 	      ǥߥɽʸ(I)
 */
int FindDelim(char *buf, char delim)
{
	int i;	/* 롼 */
	int rv = FIND_NO_DELIM;

#ifdef DBG
	DBGW(10, ("FindDelim enter.\n"));
#endif /* DBG */
	
	for (i = 0; buf[i] != '\0'; i++){
    		if(buf[i] == delim){
      			rv = i;
			goto out;
    		}
  	}

out:
#ifdef DBG
	DBGW(10, ("FindDelim exit(%d)\n", rv));
#endif /* DBG */
 	return rv; 
}

/*-----
 * MyStrtokؿ
 * 	ɸ饤֥ؿstrtokεǽ򶯲
 * strtokȤʤ
 * 	strtok֤charΥݥ󥿤ϡ裳Ȥ֤
 * 	ͤɤ߹裳֤ʸƬ
 * 	ΥǥߥޤǤʸǤ롥
 * 	ͤ0ΤȤϡ裳ˤNULLǼ롥
 * 	strtokƱɤ꤫³ˤ
 * 	裱NULLꤹ롥
 * 	strtokȰۤʤꡤ裲ˤϥǥߥʸϤ
 * 	strtokϢ³ǥߥ̵뤵뤬
 * 	MyStrtok̵뤻ˡ0֤
 * 	͡裳֤Ƭ鼡ΥǥߥޤǤʸ
 * 	        ǥߥɽʸ
 * 	        Ƭ
 */
int MyStrtok(char *s, char delim, char **top)
{
	int delim_index;	
	int rv;

#ifdef DBG
	DBGW(10, ("MyStrtok enter.\n"));
#endif /* DBG */
	
	if(s != NULL){
		delim_index = FindDelim(s, delim);
		*top = s;
		if (delim_index != FIND_NO_DELIM){
			head = s + delim_index + 1;
			s[delim_index] = '\0';
		}
		rv = delim_index;
	} else {
		delim_index = FindDelim(head, delim);
		*top = head;
		if (delim_index != FIND_NO_DELIM) {
			head[delim_index] = '\0';
			head = head + delim_index + 1;
		}
		rv = delim_index;
	}

#ifdef DBG
	DBGW(10, ("MyStrtok exit(%d)\n", rv));
#endif /* DBG */

	return rv;
}
		
/*-----
 * IsCommentLineؿ
 * 	ιԤȤιԤȽǤ롥
 * 	ʸϡδؿ̤ȥ/ڡ
 * 	Ȥ롥
 * 	//ԤιԤ⥳ȤȤߤʤ
 *	͡COMMENT_LINE, NOT_COMMENT
 *	ʸƬؤݥ
 */
int IsCommentLine(char *buf)
{
	int rv = NOT_COMMENT;
	
#ifdef DBG
	DBGW(10, ("IsCommentLine enter.\n"));
#endif /* DBG */

	DelSpaceTab(buf);
	DelComment(buf);
	
	if(buf[0] == '\n'){
		rv = COMMENT_LINE;
	}

#ifdef DBG
	DBGW(10, ("IsCommentLine exit(%d)\n", rv));
#endif /* DBG */

	return rv;
}
