/**************************************************************
 *	TMCƖxVXei߂QPj
 *
 *		java util(Ro[g)
 *
 *	Copyright (C) 2000 %%MAKER%%
 **************************************************************/
#ifndef lint
static char SccsId[] = "@(#)META21 ju_str.c 1.3 00/12/11 02:53:43";
#endif

#include <jni.h>
#include "c_dbg.h"

/* sjis 2 utf-8 */
int
JU_NewStringSJIS(JNIEnv *env, char *sjis_str, int maxlen, jstring *retstrobj)
{
	int		len;
	jbyteArray	jba = NULL;
	jclass		cls = (*env)->FindClass(env, "java/lang/String");
	jmethodID	mid;
	jstring		enc = NULL;
	int		stat;
	
	for (len=0; len<maxlen; len++) {
		if (sjis_str[len]==0)
			break;
	}
	/* c_sjisfix(sjis_str, sjis_str, len, &stat); */
	DBG(60, ("sjis:%s sjis len=%d\n", sjis_str, len));
	jba = (*env)->NewByteArray(env, len);
	(*env)->SetByteArrayRegion(env, jba, 0, len, (jbyte*)sjis_str);
	/* enc = (*env)->NewStringUTF(env, "SJIS"); */
	enc = (*env)->NewStringUTF(env, "MS932");
        
	/* new String(sjis_str,"SJIS"): constructer to specify enconding */
	mid = (*env)->GetMethodID(env, cls, "<init>", "([BLjava/lang/String;)V");
	*retstrobj = (jstring)((*env)->NewObject(env, cls, mid, jba, enc));

	if (jba != NULL)
		(*env)->DeleteLocalRef(env, jba);
	if (enc != NULL)
		(*env)->DeleteLocalRef(env, enc);
	if (cls)
		(*env)->DeleteLocalRef(env, cls);
end:
	return 0;
err:
	return 1;
}

/* utf-8 to sjis */
int
JU_GetCharSJIS(JNIEnv *env, jstring utfstr, char *outbuf, int buflen)
{
	jclass		cls = (*env)->FindClass(env, "java/lang/String");
	jmethodID	gmmid;
	jstring		enc = NULL;
	jbyteArray	sjisByte = NULL;
	jint		len, cplen;
	int		stat;
	
	/* "SJIS" ̂߂String Object擾 */
	/* enc = (*env)->NewStringUTF(env, "SJIS"); */
	enc = (*env)->NewStringUTF(env, "MS932");

	/* String#getBytes()̂߂method id擾 */
	gmmid = (*env)->GetMethodID(env, cls, "getBytes",
				    "(Ljava/lang/String;)[B");

	/* String ObjectSJISencodebyte擾 */
	sjisByte = (jbyteArray) (*env)->CallObjectMethod(env, utfstr, 
							 gmmid, enc, NULL);

	len = (*env)->GetArrayLength(env, sjisByte);
	if (len > buflen) {
		cplen = buflen;
	} else {
		cplen = len;
	}

	(*env)->GetByteArrayRegion(env, sjisByte, 0, cplen, outbuf);

	(*env)->DeleteLocalRef(env, enc);
	(*env)->DeleteLocalRef(env, sjisByte);
	/* c_sjisfix(outbuf, outbuf, buflen, &stat); */
	return 0;
err:
	if (enc)
		(*env)->DeleteLocalRef(env, enc);
	return -1;
}
