#ifndef _RS_IO_H_
#define _RS_IO_H_

/* Flags for PrintList */
#define F_LIST_SORT 	0
#define F_LIST_UNSORT	1

/* Print file init */
extern int InitOutfileList(int num_search, int dim, int myid);

/* Print a initial parameter */
extern void WriteInputData(double y[], double t_start, double t_end, double h, double dt_save);

/* Print search results per a search */
extern void PrintResultFile(double *random_vector, double fitness, int myid, int search_no, int ls_ret);

/* Print list */
extern int PrintList(FILE *fp, int num_search, int flag);

#ifdef MPI

extern int SendList(int list_size, int dim, int dest);

extern int RecvList(int write_head, int dim);

#endif /* MPI */

#endif /* _RS_IO_H_ */
